{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_calc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, math, u_talktosmc;

type

  { Tf_calc }

  Tf_calc = class(TForm)
    btn_close: TBitBtn;
    chk_knownctrl: TCheckBox;
    chg_axis: TCheckGroup;
    ed_rslt: TEdit;
    procedure CheckBox1Change(Sender: TObject);
    procedure chg_axisItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_calc: Tf_calc;

implementation

{ Tf_calc }

procedure Tf_calc.chg_axisItemClick(Sender: TObject);
var i,erg:Integer;
begin
 erg:=0;
 for i:= 0 to 15 do begin
  if chg_axis.Checked[i] then erg:= erg+round (intpower (2,i));
 end;
 ed_rslt.Text:=IntToStr(erg*-1);
end;

procedure Tf_calc.CheckBox1Change(Sender: TObject);
var i,erg:Integer;
begin
 for i:= 0 to 15 do if chk_knownctrl.Checked then begin
  chg_axis.Checked[i]:= false;
  chg_axis.CheckEnabled[i]:=smc_avail[i+1];
 end
 else begin
  chg_axis.Checked[i]:= false;
  chg_axis.CheckEnabled[i]:= true;
 end;
 erg:=0;
 for i:= 0 to 15 do begin
 if chg_axis.Checked[i]then erg:= erg+round (intpower (2,i));
 end;
 ed_rslt.Text:=IntToStr(erg*-1);
end;

procedure Tf_calc.FormShow(Sender: TObject);
var i:integer;
begin
  for i:= 1 to 16 do chg_axis.Checked[i-1]:=false;
  ed_rslt.Text:='0';
  chk_knownctrl.Checked:=false;
end;

initialization
  {$I u_calc.lrs}

end.

