{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_cfg_cl;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Spin,u_talktosmc,u_exchange, LMessages,LCLType;

type

  { Tf_cfgcl }

  Tf_cfgcl = class(TForm)
    btn_close: TBitBtn;
    btn_set: TBitBtn;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    lb_ula: TLabel;
    lb_uws: TLabel;
    Label3: TLabel;
    lb_uperiod: TLabel;
    ed_period: TLabeledEdit;
    ed_winsz: TLabeledEdit;
    ed_wintm: TLabeledEdit;
    ed_cli: TLabeledEdit;
    ed_clla: TLabeledEdit;
    lbx_set: TListBox;
    rg_cloop: TRadioGroup;
    rg_selpos: TRadioGroup;
    spe_axis: TSpinEdit;
    procedure btn_setClick(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
  private
    procedure readvar;
    function vc2_err: boolean;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_cfgcl: Tf_cfgcl;

implementation

{ Tf_cfgcl }

function Tf_cfgcl.vc2_err:boolean;
var s,t:string;
begin
 s:=trim (smc_cmd_v2('','gne',spe_axis.Value,1)); sleep (10);
 t:=trim (smc_cmd_v2('','ngsp',spe_axis.Value,1)); sleep (10);
 if (s='0') and (t='0') then vc2_err:=false else begin
  if t<>'0' then begin
   smc_cmd_v2('','nclear',spe_axis.Value,0); sleep (10);
  end;
  vc2_err:=true;
 end;
end;

procedure Tf_cfgcl.readvar;
var s:string;
    k,err:integer;
begin
 vc2_err;
 lbx_set.Clear;
 ed_period.Clear; ed_period.Color:=clwhite;
 ed_cli.Clear; ed_cli.Color:=clwhite;
 ed_clla.Clear; ed_clla.Color:=clwhite;
 ed_winsz.Clear; ed_winsz.Color:=clwhite;
 ed_wintm.Clear; ed_wintm.Color:=clwhite;
 lb_uperiod.Caption:=actunit[spe_axis.Value];
 lb_ula.Caption:=actunit[spe_axis.Value];
 lb_uws.Caption:=actunit[spe_axis.Value];
 ed_period.Text:=trim (smc_cmd_v2('','getclperiod',spe_axis.Value,1)); sleep (10);
 s:=trim (smc_cmd_v2('','getcloop',spe_axis.Value,1)); sleep (10);
 val (s,k,err);
 if err<>0 then k:=1;
 rg_cloop.ItemIndex:=k;
 s:=trim (smc_cmd_v2('','getselpos',spe_axis.Value,1)); sleep (10);
 val (s,k,err);
 if err<>0 then k:=1;
 rg_selpos.ItemIndex:=k;
 ed_cli.Text:= trim (smc_cmd_v2('2','getsp',spe_axis.Value,1)); sleep (10);
 ed_clla.Text:= trim (smc_cmd_v2('7','getsp',spe_axis.Value,1)); sleep (10);
 ed_winsz.Text:=trim (smc_cmd_v2('','getclwindow',spe_axis.Value,1)); sleep (10);
 ed_wintm.Text:=trim (smc_cmd_v2('','getclwintime',spe_axis.Value,1)); sleep (10);
end;

procedure Tf_cfgcl.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
  if msg.CharCode=27 then smc_cmd_v2(#3,'',0,0);  
end;

procedure Tf_cfgcl.btn_setClick(Sender: TObject);
var s,res:string;
    k,err:integer;
begin
 btn_close.Enabled:=false;
 vc2_err;
 lbx_set.Clear;
 if rg_cloop.ItemIndex= 1 then begin
  lbx_set.Items.Add('0 '+IntToStr(spe_axis.Value)+' setaxis');
  smc_cmd_v2('0','setaxis',spe_axis.Value,0); sleep (10);
  showmessage ('Axis off');
 end;
 lbx_set.Items.Add(IntToStr(rg_cloop.ItemIndex)+' '+IntToStr(spe_axis.Value)+' setcloop');
 smc_cmd_v2(IntToStr(rg_cloop.ItemIndex)+'','setcloop',spe_axis.Value,0); sleep (10);
 res:=trim (smc_cmd_v2('','getcloop',spe_axis.Value,1)); sleep (10);
 val (res,k,err);
 if err<>0 then k:=1;
 rg_cloop.ItemIndex:=k;
 Application.ProcessMessages;
 lbx_set.Items.Add(IntToStr(rg_selpos.ItemIndex)+' '+IntToStr(spe_axis.Value)+' setnselpos');
 smc_cmd_v2(IntToStr(rg_selpos.ItemIndex)+'','setselpos',spe_axis.Value,0); sleep (10);
 res:=trim (smc_cmd_v2('','getselpos',spe_axis.Value,1)); sleep (10);
 val (res,k,err);
 if err<>0 then k:=1;
 rg_selpos.ItemIndex:=k;
 Application.ProcessMessages;
 s:=StringReplace(ed_period.Text,',','.',[ rfReplaceAll]);
 lbx_set.Items.Add(s+' '+IntToStr(spe_axis.Value)+' setclperiod');
 smc_cmd_v2(s+'','setclperiod',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_period.Color:=clred else ed_period.Color:=clWhite;
 ed_period.Text:=trim (smc_cmd_v2('','getclperiod',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 s:=StringReplace(ed_cli.Text,',','.',[ rfReplaceAll]);
 lbx_set.Items.Add(s+' 2 '+IntToStr(spe_axis.Value)+' setsp');
 smc_cmd_v2(s+' 2','setsp',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_cli.Color:=clred else ed_cli.Color:=clWhite;
 ed_cli.Text:= trim (smc_cmd_v2('2','getsp',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 s:=StringReplace(ed_clla.Text,',','.',[ rfReplaceAll]);
 lbx_set.Items.Add(s+' 7 '+IntToStr(spe_axis.Value)+' setsp');
 smc_cmd_v2(s+' 7','setsp',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_clla.Color:=clred else ed_clla.Color:=clWhite;
 ed_clla.Text:= trim (smc_cmd_v2('7','getsp',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 s:=StringReplace(ed_winsz.Text,',','.',[ rfReplaceAll]);
 lbx_set.Items.Add(s+' '+IntToStr(spe_axis.Value)+' setclwindow');
 smc_cmd_v2(s+'','setclwindow',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_winsz.Color:=clred else ed_winsz.Color:=clWhite;
 ed_winsz.Text:=trim (smc_cmd_v2('','getclwindow',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 s:=StringReplace(ed_wintm.Text,',','.',[ rfReplaceAll]);
 lbx_set.Items.Add(s+' '+IntToStr(spe_axis.Value)+' setclwintime');
 smc_cmd_v2(s+'','setclwintime',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_wintm.Color:=clred else ed_wintm.Color:=clWhite;
 ed_wintm.Text:=trim (smc_cmd_v2('','getclwintime',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 btn_close.Enabled:=true;
end;

procedure Tf_cfgcl.FormShow(Sender: TObject);
begin
 lbx_set.Clear;
 spe_axis.MinValue:= LowAxisNo;
 spe_axis.MaxValue:=HighAxisNo;
 spe_axis.Enabled:=smc_count>1;
 spe_axis.Value:=CAxis;
 lb_ula.Caption:=actunit[spe_axis.Value];
 lb_uperiod.Caption:=actunit[spe_axis.Value];
 lb_uws.Caption:=actunit[spe_axis.Value];
 btn_set.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_period.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_cli.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_clla.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_winsz.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_wintm.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 rg_cloop.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 rg_selpos.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 if (smc_avail[spe_axis.Value]) and (acl_ctrl [spe_axis.Value]) then readvar;
end;

procedure Tf_cfgcl.spe_axisChange(Sender: TObject);
begin
 lbx_set.Clear;
 lb_ula.Caption:=actunit[spe_axis.Value];
 lb_uperiod.Caption:=actunit[spe_axis.Value];
 lb_uws.Caption:=actunit[spe_axis.Value];
 btn_set.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_period.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_cli.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_clla.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_winsz.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 ed_wintm.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 rg_cloop.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 rg_selpos.Enabled:=(smc_avail[spe_axis.Value]) and (acl_ctrl[spe_axis.Value]);
 if (smc_avail[spe_axis.Value]) and (acl_ctrl [spe_axis.Value]) then readvar;
end;

procedure Tf_cfgcl.spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_axis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_axis.Value:=nw;
   spe_axisChange(nil);
  end;
 end;
end;

initialization
  {$I u_cfg_cl.lrs}

end.

