{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_cfg_powerup;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Buttons, LMessages,u_exchange,u_talktosmc, Spin,LCLType;

type

  { Tf_powerup }

  Tf_powerup = class(TForm)
    btn_close: TBitBtn;
    btn_set: TBitBtn;
    ch_pwup: TCheckGroup;
    spe_axis: TSpinEdit;
    procedure btn_setClick(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
  private
    procedure readvar;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_powerup: Tf_powerup;

implementation

{ Tf_powerup }

procedure Tf_powerup.readvar;
var s:string;
    j,k,err:integer;
begin
 s:=trim (smc_cmd_v2('','getnpowerup',spe_axis.Value,1)); sleep (30);
 if s='' then begin
  s:=trim (smc_cmd_v2('','gne',spe_axis.Value,1)); sleep (30);
  smc_cmd_v2('','nclear',spe_axis.Value,0); sleep (30);
  if s='2000' then btn_set.Enabled:=false;
 end
 else begin
  btn_set.Enabled:=true;
  val (s,j,err);
  if err<>0 then j:=0;
  k:=j; ch_pwup.Checked[0]:=(k and 1)=1;
  k:=j; ch_pwup.Checked[1]:=(k and 2)=2;
  k:=j; ch_pwup.Checked[2]:=(k and 4)=4;
  k:=j; ch_pwup.Checked[3]:=(k and 8)=8;
  k:=j; ch_pwup.Checked[4]:=(k and 16)=16;
  k:=j; ch_pwup.Checked[5]:=(k and 32)=32;
  k:=j; ch_pwup.Checked[6]:=(k and 64)=64;
  k:=j; ch_pwup.Checked[7]:=(k and 128)=128;
 end;
end;

procedure Tf_powerup.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
  if msg.CharCode=27 then smc_cmd_v2(#3,'',0,0);  
end;

procedure Tf_powerup.btn_setClick(Sender: TObject);
var j:integer;
begin
 btn_close.Enabled:=false;
 j:=0;
 if ch_pwup.Checked[0] then inc (j,1);
 if ch_pwup.Checked[1] then inc (j,2);
 if ch_pwup.Checked[2] then inc (j,4);
 if ch_pwup.Checked[3] then inc (j,8);
 if ch_pwup.Checked[4] then inc (j,16);
 if ch_pwup.Checked[5] then inc (j,32);
 if ch_pwup.Checked[6] then inc (j,64);
 if ch_pwup.Checked[7] then inc (j,128);
 smc_cmd_v2(IntToStr(j),'setnpowerup',spe_axis.Value,0); sleep (50);
 btn_close.Enabled:=true;
end;

procedure Tf_powerup.FormShow(Sender: TObject);
var s:string;
    f:TextFile;
    i:integer;
begin
 ch_pwup.Items.Clear; i:=0;
 assignfile (f,ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'powerup.txt'); reset (f);
 readln (f,s); //dummy for hint
 while not eof(f) do begin
  readln (f,s); s:=trim (s);
  if s<>'' then begin
   if LowerCase(s)<>'nil' then ch_pwup.Items.Add(s) else ch_pwup.Items.Add('-');
   ch_pwup.CheckEnabled[i]:=s<>'nil';
   inc (i);
  end;
 end;
 CloseFile(f);
 spe_axis.MinValue:= LowAxisNo;
 spe_axis.MaxValue:=HighAxisNo;
 spe_axis.Enabled:=smc_count>1;
 spe_axis.Value:=CAxis;
 btn_set.Enabled:=smc_avail[spe_axis.Value];
 if smc_avail[spe_axis.Value] then readvar;
end;

procedure Tf_powerup.spe_axisChange(Sender: TObject);
begin
 btn_set.Enabled:=smc_avail[spe_axis.Value];
 ch_pwup.Enabled:=smc_avail[spe_axis.Value];
 if smc_avail[spe_axis.Value] then readvar;
end;

procedure Tf_powerup.spe_axisKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_axis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_axis.Value:=nw;
   spe_axisChange(nil);
  end;
 end;
end;

initialization
  {$I u_cfg_powerup.lrs}

end.

