{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_cfg_uservar;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Buttons, StdCtrls,u_talktosmc,u_dbg,u_exchange, Spin, LMessages,LCLType;

type

  { Tf_uservar }

  Tf_uservar = class(TForm)
    btn_set: TBitBtn;
    btn_close: TBitBtn;
    ed_var0: TLabeledEdit;
    ed_var9: TLabeledEdit;
    ed_var1: TLabeledEdit;
    ed_var2: TLabeledEdit;
    ed_var3: TLabeledEdit;
    ed_var4: TLabeledEdit;
    ed_var5: TLabeledEdit;
    ed_var6: TLabeledEdit;
    ed_var7: TLabeledEdit;
    ed_var8: TLabeledEdit;
    lbx_set: TListBox;
    spe_axis: TSpinEdit;
    procedure btn_setClick(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
  private
    procedure readvar;
    function vc2_err: boolean;
    { private declarations }
  public
    { public declarations }
  end; 


var
  f_uservar: Tf_uservar;

implementation

{ Tf_uservar }
procedure Tf_uservar.readvar;
begin
 vc2_err;
 lbx_set.Clear;
 ed_var0.Clear; ed_var0.Color:=clwhite;
 ed_var1.Clear; ed_var1.Color:=clwhite;
 ed_var2.Clear; ed_var2.Color:=clwhite;
 ed_var3.Clear; ed_var3.Color:=clwhite;
 ed_var4.Clear; ed_var4.Color:=clwhite;
 ed_var5.Clear; ed_var5.Color:=clwhite;
 ed_var6.Clear; ed_var6.Color:=clwhite;
 ed_var7.Clear; ed_var7.Color:=clwhite;
 ed_var8.Clear; ed_var8.Color:=clwhite;
 ed_var9.Clear; ed_var9.Color:=clwhite;
 ed_var0.Text:= trim (smc_cmd_v2('0','getuv',spe_axis.Value,1)); sleep (10);
 ed_var1.Text:= trim (smc_cmd_v2('1','getuv',spe_axis.Value,1)); sleep (10);
 ed_var2.Text:= trim (smc_cmd_v2('2','getuv',spe_axis.Value,1)); sleep (10);
 ed_var3.Text:= trim (smc_cmd_v2('3','getuv',spe_axis.Value,1)); sleep (10);
 ed_var4.Text:= trim (smc_cmd_v2('4','getuv',spe_axis.Value,1)); sleep (10);
 ed_var5.Text:= trim (smc_cmd_v2('5','getuv',spe_axis.Value,1)); sleep (10);
 ed_var6.Text:= trim (smc_cmd_v2('6','getuv',spe_axis.Value,1)); sleep (10);
 ed_var7.Text:= trim (smc_cmd_v2('7','getuv',spe_axis.Value,1)); sleep (10);
 ed_var8.Text:= trim (smc_cmd_v2('8','getuv',spe_axis.Value,1)); sleep (10);
 ed_var9.Text:= trim (smc_cmd_v2('9','getuv',spe_axis.Value,1)); sleep (10);
end;

function Tf_uservar.vc2_err:boolean;
var s,t:string;
begin
 s:=trim (smc_cmd_v2('','gne',spe_axis.Value,1)); sleep (10);
 t:=trim (smc_cmd_v2('','ngsp',spe_axis.Value,1)); sleep (10);
 if (s='0') and (t='0') then vc2_err:=false else begin
  if t<>'0' then begin
   smc_cmd_v2('','nclear',spe_axis.Value,0); sleep (10);
  end;
  vc2_err:=true;
 end;
end;

procedure Tf_uservar.FormShow(Sender: TObject);
begin
 lbx_set.Clear;
 ed_var0.Clear; ed_var0.Color:=clwhite;
 ed_var1.Clear; ed_var1.Color:=clwhite;
 ed_var2.Clear; ed_var2.Color:=clwhite;
 ed_var3.Clear; ed_var3.Color:=clwhite;
 ed_var4.Clear; ed_var4.Color:=clwhite;
 ed_var5.Clear; ed_var5.Color:=clwhite;
 ed_var6.Clear; ed_var6.Color:=clwhite;
 ed_var7.Clear; ed_var7.Color:=clwhite;
 ed_var8.Clear; ed_var8.Color:=clwhite;
 ed_var9.Clear; ed_var9.Color:=clwhite;
 spe_axis.MinValue:= LowAxisNo;
 spe_axis.MaxValue:=HighAxisNo;
 spe_axis.Enabled:=smc_count>1;
 spe_axis.Value:=CAxis;
 btn_set.Enabled:=smc_avail[spe_axis.Value];
 if smc_avail[spe_axis.Value] then readvar;
end;

procedure Tf_uservar.spe_axisChange(Sender: TObject);
begin
 btn_set.Enabled:=smc_avail[spe_axis.Value];
 ed_var0.Enabled:=smc_avail[spe_axis.Value];
 ed_var1.Enabled:=smc_avail[spe_axis.Value];
 ed_var2.Enabled:=smc_avail[spe_axis.Value];
 ed_var3.Enabled:=smc_avail[spe_axis.Value];
 ed_var4.Enabled:=smc_avail[spe_axis.Value];
 ed_var5.Enabled:=smc_avail[spe_axis.Value];
 ed_var6.Enabled:=smc_avail[spe_axis.Value];
 ed_var7.Enabled:=smc_avail[spe_axis.Value];
 ed_var8.Enabled:=smc_avail[spe_axis.Value];
 ed_var9.Enabled:=smc_avail[spe_axis.Value];
 lbx_set.Clear;
 if smc_avail[spe_axis.Value] then readvar
 else begin
  ed_var0.Clear; ed_var0.Color:=clwhite;
  ed_var1.Clear; ed_var1.Color:=clwhite;
  ed_var2.Clear; ed_var2.Color:=clwhite;
  ed_var3.Clear; ed_var3.Color:=clwhite;
  ed_var4.Clear; ed_var4.Color:=clwhite;
  ed_var5.Clear; ed_var5.Color:=clwhite;
  ed_var6.Clear; ed_var6.Color:=clwhite;
  ed_var7.Clear; ed_var7.Color:=clwhite;
  ed_var8.Clear; ed_var8.Color:=clwhite;
  ed_var9.Clear; ed_var9.Color:=clwhite;
 end;
end;

procedure Tf_uservar.spe_axisKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_axis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_axis.Value:=nw;
   spe_axisChange(nil);
  end;
 end;
end;

procedure Tf_uservar.btn_setClick(Sender: TObject);
begin
 btn_close.Enabled:=false;
 vc2_err;
 lbx_set.Clear;
 lbx_set.Items.Add(ed_var0.Text+' 0 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var0.Text+' 0','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var0.Color:=clred else ed_var0.Color:=clWhite;
 ed_var0.Text:= trim (smc_cmd_v2('0','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var1.Text+' 1 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var1.Text+' 1','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var1.Color:=clred else ed_var1.Color:=clwhite;
  ed_var1.Text:= trim (smc_cmd_v2('1','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var2.Text+' 2 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var2.Text+' 2','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var2.Color:=clred else ed_var2.Color:=clwhite;
 ed_var2.Text:= trim (smc_cmd_v2('2','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var3.Text+' 3 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var3.Text+' 3','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var3.Color:=clred else ed_var3.Color:=clwhite;
 ed_var3.Text:= trim (smc_cmd_v2('3','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var4.Text+' 4 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var4.Text+' 4','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var4.Color:=clred else ed_var4.Color:=clwhite;
 ed_var4.Text:= trim (smc_cmd_v2('4','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var5.Text+' 5 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var5.Text+' 5','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var5.Color:=clred else ed_var5.Color:=clwhite;
 ed_var5.Text:= trim (smc_cmd_v2('5','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var6.Text+' 6 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var6.Text+' 6','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var6.Color:=clred else ed_var6.Color:=clwhite;
 ed_var6.Text:= trim (smc_cmd_v2('6','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var7.Text+' 7 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var7.Text+' 7','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var7.Color:=clred else ed_var7.Color:=clwhite;
 ed_var7.Text:= trim (smc_cmd_v2('7','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var8.Text+' 8 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var8.Text+' 8','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var8.Color:=clred else ed_var8.Color:=clwhite;
 ed_var8.Text:= trim (smc_cmd_v2('8','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 lbx_set.Items.Add(ed_var9.Text+' 9 '+IntToStr(spe_axis.Value)+' setuv');
 smc_cmd_v2(ed_var9.Text+' 9','setuv',spe_axis.Value,0); sleep (10);
 if vc2_err then ed_var9.Color:=clred else ed_var9.Color:=clwhite;
 ed_var9.Text:= trim (smc_cmd_v2('9','getuv',spe_axis.Value,1)); sleep (10);
 Application.ProcessMessages;
 btn_close.Enabled:=true;
end;

procedure Tf_uservar.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
  if msg.CharCode=27 then smc_cmd_v2(#3,'',0,0);  
end;

initialization
  {$I u_cfg_uservar.lrs}

end.

