{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_chginc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons,u_exchange, Spin;

type

  { Tf_chginc }

  Tf_chginc = class(TForm)
    btn_ok: TBitBtn;
    btn_cancel: TBitBtn;
    ed_value: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    spe_decplaces: TSpinEdit;
    procedure btn_okClick(Sender: TObject);
    procedure btn_cancelClick(Sender: TObject);
    procedure ed_valueChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    oldinc:single;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_chginc: Tf_chginc;

implementation

{ Tf_chginc }

procedure Tf_chginc.btn_okClick(Sender: TObject);
begin
 bok:=true;
 decplc:=spe_decplaces.Value;
end;

procedure Tf_chginc.btn_cancelClick(Sender: TObject);
begin
  newinc:=oldinc;
  bok:=false;
end;

procedure Tf_chginc.ed_valueChange(Sender: TObject);
var err:integer;
     s:string;
begin
  err:=0;
  s:=ed_value.Text;
  if pos(',',s)>0 then s[pos(',',s)]:='.';
  val (s,newinc,err);
  btn_ok.enabled:=err=0;
end;

procedure Tf_chginc.FormShow(Sender: TObject);
begin
  oldinc:=newinc;
  spe_decplaces.Value:=decplc;
  ed_value.Text:=FormatFloat('0.000000',newinc);
end;

initialization
  {$I u_chginc.lrs}

end.

