{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_cldiag;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, ExtCtrls,u_talktosmc,u_exchange, StdCtrls, LMessages;

type

  { Tf_cldiag }

  Tf_cldiag = class(TForm)
    btn_clear: TBitBtn;
    btn_stop: TBitBtn;
    btn_diag: TBitBtn;
    btn_save: TBitBtn;
    btn_close: TBitBtn;
    Image1: TImage;
    lb_xlow: TLabel;
    lb_xhigh: TLabel;
    lb_ylow: TLabel;
    lb_yhigh: TLabel;
    rg_x: TRadioGroup;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    procedure btn_diagClick(Sender: TObject);
    procedure btn_saveClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure btn_clearClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { private declarations }
  oldvel:string;
  cnt,xhw,xlw,ylw,yhw,oldx,oldy:integer;
  frst:boolean;
  procedure read_scale;
  public
    { public declarations }
  end; 

var
  f_cldiag: Tf_cldiag;

implementation

{ Tf_cldiag }

procedure Tf_cldiag.Timer1Timer(Sender: TObject);
begin
  read_scale;
end;

procedure Tf_cldiag.read_scale;
var s,t,u:string;
    it,iu,err,x,y:integer;
begin
 s:=smc_cmd_v2('','a',CAxis,1);
 t:=copy (s,1,pos(' ',s)-1);
 u:=s; delete (u,1,pos(' ',s));
 val (trim(t),it,err);
 if it<xlw then xlw:=it;
 if it>xhw then xhw:=it;
 val (Trim(u),iu,err);
 if iu<ylw then ylw:=iu;
 if iu>yhw then yhw:=iu;
 x:=275-round(it*270/32767);
 y:=275-round(iu*270/32767);
 Image1.Canvas.Pen.Color:=clred;
 if rg_x.ItemIndex=0 then if frst then Image1.Canvas.MoveTo(x,y) else Image1.Canvas.LineTo(x,y);
 Image1.Canvas.Pen.Color:=clBlue;
 if (rg_x.ItemIndex=1)  or (rg_x.ItemIndex=3) then if frst then Image1.Canvas.MoveTo(cnt,x) else Image1.Canvas.Line(cnt-1,oldx,cnt,x);
 Image1.Canvas.Pen.Color:=clLime;
 if (rg_x.ItemIndex=2) or (rg_x.ItemIndex=3) then if frst then Image1.Canvas.MoveTo(cnt,y) else Image1.Canvas.Line(cnt-1,oldy,cnt,y);
 oldx:=x;  oldy:=y;
 inc (cnt);  frst:=false;
 if cnt>=550 then begin
  Timer1.Enabled:=false;
  smc_cmd_v2('',#3,CAxis,0); sleep (10);
  smc_cmd_v2(oldvel,'snv',CAxis,0); sleep (10);
  lb_xlow.Caption:='sin low = '+IntToStr(xlw);
  lb_xhigh.Caption:='sin high = '+IntToStr(xhw);
  lb_ylow.Caption:='cos low = '+IntToStr(ylw);
  lb_yhigh.Caption:='cos high = '+IntToStr(yhw);
  btn_clear.Enabled:=true;
  btn_diag.Enabled:=true;
  btn_save.Enabled:=true;
  btn_close.Enabled:=true;
  btn_stop.Enabled:=false;
  rg_x.Enabled:=true;
 end;
end;

procedure Tf_cldiag.btn_diagClick(Sender: TObject);
var s:string;
    clp,tstdist:double;
    err:integer;
begin
 btn_clear.Enabled:=false;
 btn_diag.Enabled:=false;
 btn_save.Enabled:=false;
 btn_close.Enabled:=false;
 btn_stop.Enabled:=true;
 rg_x.Enabled:=false;
 cnt:=0;  xlw:=65535; xhw:=-65535;
 frst:=true; ylw:=65535; yhw:=-65535;
 oldvel:= trim (smc_cmd_v2('','gnv',CAxis,1)); sleep (10);
 s:= trim (smc_cmd_v2('','getclperiod',CAxis,1)); sleep (10);
 val (s,clp,err);
 if err=0 then begin
  Image1.Canvas.Pen.Color:=clWhite;
  if rg_x.ItemIndex >0 then Image1.Canvas.Line(0,275,549,275);
  tstdist:=5*abs(clp);
  smc_cmd_v2(FormatFloat('0.000000',tstdist/25),'snv',CAxis,0); sleep (10);
  smc_cmd_v2(FormatFloat('0.000000',tstdist),'nr',CAxis,0);
  Timer1.Enabled:=true;
 end;
end;

procedure Tf_cldiag.btn_saveClick(Sender: TObject);
begin
 SaveDialog1.InitialDir:=ProgramDir;
 if (SaveDialog1.Execute) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
  Image1.Picture.SaveToFile(SaveDialog1.FileName);
 end;
end;

procedure Tf_cldiag.btn_stopClick(Sender: TObject);
begin
  smc_cmd_v2(#3,'',0,0);sleep (10);
  smc_cmd_v2(oldvel,'snv',CAxis,0); sleep (10);
  Timer1.Enabled:=false;
 btn_clear.Enabled:=true;
 btn_diag.Enabled:=true;
 btn_save.Enabled:=true;
 btn_close.Enabled:=true;
 btn_stop.Enabled:=false;
 rg_x.Enabled:=true;
end;

procedure Tf_cldiag.btn_clearClick(Sender: TObject);
begin
 Image1.Canvas.Clear;
 Image1.Canvas.Brush.Color := clBlack;
 Image1.Canvas.FillRect(0,0,549,549);
 lb_xlow.Caption:='';
 lb_xhigh.Caption:='';
 lb_ylow.Caption:='';
 lb_yhigh.Caption:='';
end;

procedure Tf_cldiag.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
smc_cmd_v2(#3,'',0,0);sleep (10);
smc_cmd_v2(oldvel,'snv',CAxis,0); sleep (10);
Timer1.Enabled:=false;
end;


procedure Tf_cldiag.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
  if msg.CharCode=27 then btn_stopClick(nil);
end;

procedure Tf_cldiag.FormShow(Sender: TObject);
begin
 Image1.Canvas.Clear;
 Image1.Canvas.Brush.Color := clBlack;
 Image1.Canvas.FillRect(0,0,549,549);
 lb_xlow.Caption:='';
 lb_xhigh.Caption:='';
 lb_ylow.Caption:='';
 lb_yhigh.Caption:='';
 oldx:=0; oldy:=0;
 btn_clear.Enabled:=false;
 btn_diag.Enabled:=true;
 btn_save.Enabled:=false;
 btn_close.Enabled:=true;
 btn_stop.Enabled:=false;
 rg_x.Enabled:=true;
end;

initialization
  {$I u_cldiag.lrs}

end.

