{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_createclone;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls, ComCtrls,u_talktosmc,u_exchange,u_editccfg;

type

  { Tf_mkclone }

  Tf_mkclone = class(TForm)
    btn_close: TBitBtn;
    btn_save: TBitBtn;
    btn_crt: TBitBtn;
    btn_stop: TBitBtn;
    ed_comment: TLabeledEdit;
    lbx_clone: TListBox;
    ProgressBar1: TProgressBar;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure btn_saveClick(Sender: TObject);
    procedure btn_crtClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbx_cloneDblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    ii,errcnt:integer;
    usr_cmt:boolean;
    okstr,clonevers_str:string;
    gcmd_str,scmd_str:string;
    CfgLst:TStringList;
    procedure doit;
    function get_para(cp: string): string;
    function mk_errchk: boolean;
    { private declarations }
    
  public
    { public declarations }
  end; 

var
  f_mkclone: Tf_mkclone;

implementation

{ Tf_mkclone }

function Tf_mkclone.get_para(cp:string):string;
var prow,i,err:Integer;
    s,t:string;
    dmy:double;
begin
 val (cp,dmy,err);
 if (cp<>'') and (err=0) then begin
  prow:=round (frac(dmy)*10);
  if prow=0 then s:=smc_ans
  else begin
   t:=trim (smc_ans)+' ';
   for i:=1 to prow do begin
    s:=copy (t,1,pos(' ',t)-1);
    delete (t,1,pos(' ',t)-1);
    t:=TrimLeft(t);
   end;
  end;
 end
 else begin
  s:='# ERROR: ';
  inc (errcnt);
 end;
 get_para:=s;
end;

function Tf_mkclone.mk_errchk:boolean;
var dmy1,s,t:string;
begin
 mk_errchk:=true;
 dmy1:=trim (smc_ans);
 sleep (Timer1.Interval div 3);
 s:=trim(smc_cmd_v2('','gne',CAxis,1));
 sleep (Timer1.Interval  div 3);
 t:=trim(smc_cmd_v2('','ngsp',CAxis,1));
 if t<>'0' then smc_cmd_v2('','nclear',CAxis,0);
 if (s='0') and (t='0') and (dmy1<>'') then okstr:='' else begin
  okstr:='# ERROR ';
  mk_errchk:=false;
  inc (errcnt);
 end;
 smc_ans:=dmy1;
end;

procedure Tf_mkclone.doit;
var s,oldcmd,parstr,ignstr,dmy:string;
begin
 Application.ProcessMessages;
 ProgressBar1.Position:=ii+1;
 oldcmd:='';
 s:= CfgLst[ii];
 if pos ('### ',s)=1 then begin
  lbx_clone.Items.Add(s);
 end
 else begin
  ignstr:='';
  scmd_str:= trim (copy (s,1,pos(';',s)-1));
  if (scmd_str<>'') and (scmd_str[1]='#') then begin
   delete (scmd_str,1,1);
   ignstr:='# ';
  end;
  gcmd_str:=s; delete (gcmd_str,1,pos(';',gcmd_str));
  parstr:=trim (copy (scmd_str,Pos('$',scmd_str)+1,3));
  Delete(scmd_str,Pos('$',scmd_str),Pos(' ',scmd_str)-1);
  if oldcmd<>gcmd_str then begin
   cmd_check(gcmd_str);
   gcmd_str:=StringReplace(gcmd_str,'%',IntToStr(CAxis),[rfReplaceAll]);
   if pos ('getaxisno',gcmd_str)=0 then begin
    smc_cmd_v2(gcmd_str,'',0,smc_return);
    mk_errchk;
    dmy:=ignstr+okstr+get_para(parstr)+scmd_str;
    dmy:=StringReplace(dmy,'  ',' ',[rfReplaceAll]);
    lbx_clone.Items.Add(dmy);
   end
   else begin
    dmy:=ignstr+okstr+IntToStr(CAxis)+scmd_str;
    dmy:=StringReplace(dmy,'  ',' ',[rfReplaceAll]);
    lbx_clone.Items.Add(dmy);
   end;
  end
  else begin
  dmy:=ignstr+okstr+get_para(parstr)+scmd_str;
  dmy:=StringReplace(dmy,'  ',' ',[rfReplaceAll]);
  lbx_clone.Items.Add(dmy);
  end;
  oldcmd:=gcmd_str;
 end;
 if (ii <CfgLst.Count-1) then begin
  inc(ii);
  if (ii>3) then begin
   lbx_clone.ItemIndex:=lbx_clone.Items.Count-1;
   lbx_clone.TopIndex:=ii-3;
  end;
 end
 else begin
  Timer1.Enabled:=false;
  btn_save.Enabled:=true;
  btn_crt.Enabled:=true;
  btn_stop.Enabled:=false;
  btn_close.Enabled:=true;
  ed_comment.Enabled:=true;
  ProgressBar1.Position:=CfgLst.Count;
  Application.ProcessMessages;
  if errcnt<>0 then ShowMessage('There '+IntToStr(errcnt)+' errors detected!');
  sleep (1000);
  f_mkclone.ActiveControl:=lbx_clone;
  lbx_clone.TopIndex:=0;
  lbx_clone.Selected[0]:=true;
  lbx_clone.ItemIndex:=0;
 end;
end;

procedure Tf_mkclone.FormShow(Sender: TObject);
var cfgfile:textfile;
    s:string;
    cnt,ps:integer;
    strt:boolean;
begin
  cnt:=0;strt:=false; clonevers_str:='';
  lbx_clone.ShowHint:=bshowhint;
  ed_comment.ShowHint:=bshowhint;
  lbx_clone.Clear;
  Timer1.Enabled:=false;
  Timer1.Interval:=pollingtime*2;
  btn_crt.Enabled:=ctrl_ident<>'hydra';
  btn_stop.Enabled:=false;
  btn_save.Enabled:=false;
  ed_comment.Text:='';
  ed_comment.Enabled:=ctrl_ident<>'hydra';
  if ctrl_ident<>'hydra' then f_mkclone.ActiveControl:=ed_comment else f_mkclone.ActiveControl:=btn_close;
  smc_cmd_v2('','gne',CAxis,1);
  smc_cmd_v2('','nclear',CAxis,0);
  ProgressBar1.Position:=0;
  ProgressBar1.Color:=clGray;
  ProgressBar1.Color:=clLime;
  cfglst:=TStringList.Create;
  diff_ctrl:=true;
  if (diff_ctrl=true) and (pos('pollux',ctrl_ident)>0) then begin
  s:=trim(smc_cmd_v2('','nidentify',CAxis,1));
  s:=LowerCase(copy (s,1,pos(' ',s)));
  if s='pollux ' then AssignFile(cfgfile,ProgramDir+DirSep+'controller'+DirSep+'pollux'+DirSep+'makeclone.txt');
  if s='pollux2 ' then AssignFile(cfgfile,ProgramDir+DirSep+'controller'+DirSep+'pollux-nt'+DirSep+'makeclone.txt');
 end
 else AssignFile(cfgfile,ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'makeclone.txt');
  Reset(cfgfile);
  while not eof (cfgfile) do begin
   readln (cfgfile,s);
   if ctrl_ident='hydra' then lbx_clone.Items.Add(s);
   if trim (s) <>'' then begin
    inc (cnt);
    if Pos('# ',s)=1 then begin
     delete (s,1,1);
     s:='#'+trim (s);
    end;
    ps:=pos('Clone-Config-Version:',s);
    if ps>0 then clonevers_str:= trim (copy (s,ps,ps+28));
    if strt then CfgLst.add (s);
    if (cnt>1) and (pos('#####',s)>0) then strt:=true;
   end;
  end;
  CloseFile(cfgfile);
end;

procedure Tf_mkclone.lbx_cloneDblClick(Sender: TObject);
var a,b:integer;
    s:string;
begin
 if (ctrl_ident<>'hydra') and (Timer1.Enabled=false) then begin
  a:=lbx_clone.ItemIndex;
  if usr_cmt=false then b:=7 else b:=8;
  if (a>b) or ((usr_cmt=true) and (a=3)) then begin
   s:=lbx_clone.Items[a];
   f_editccfg.ed_line.Text:=s;
   f_editccfg.ShowModal;
   if f_editccfg.ModalResult=mrOK then lbx_clone.Items[a]:=f_editccfg.ed_line.Text;
  end;
 end;
end;

procedure Tf_mkclone.Timer1Timer(Sender: TObject);
begin
  doit;
end;

procedure Tf_mkclone.btn_saveClick(Sender: TObject);
var dmy:string;
begin
  If (ed_comment.Text<>'') and (Pos ('# Serialnumber of the SMC-Controller: ',lbx_clone.Items[3])=1) then begin
   usr_cmt:=true;
   dmy:='# '+ed_comment.Text;
   while length (dmy) <62 do dmy:=dmy+' ';
   lbx_clone.Items.Insert(3,dmy+' #');
  end;
  SaveDialog1.InitialDir:=ProgramDir+DirSep+'clonecfg'+DirSep+ctrl_dir;
  SaveDialog1.Filter:='Clone-Files (*.ccf)|*.ccf';
  SaveDialog1.DefaultExt:='.ccf';
  SaveDialog1.FileName:='';
  if (SaveDialog1.Execute) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
   btn_save.Enabled:=false;
   lbx_clone.Items.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure Tf_mkclone.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  CfgLst.Free;
end;

procedure Tf_mkclone.btn_crtClick(Sender: TObject);
const c_line:string[64]='################################################################';
var dmy:string;
begin
  errcnt:=0;
  okstr:='';
  ed_comment.Enabled:=false;
  btn_crt.Enabled:=false;
  btn_stop.Enabled:=true;
  btn_close.Enabled:=false;
  btn_save.Enabled:=false;
  f_mkclone.ActiveControl:=btn_stop;
  ProgressBar1.Position:=0;
  ProgressBar1.Max:=CfgLst.Count;
  lbx_clone.Clear;
  lbx_clone.Items.Add(c_line);
  dmy:='# Create-time of the configuration: '+FormatDateTime ('YYYY-MM-DD hh:mm:ss',now);
  while length (dmy) <62 do dmy:=dmy+' ';
  lbx_clone.Items.Add(dmy+' #');
  dmy:='# '+progvers+',  '+clonevers_str;
  while length (dmy) <62 do dmy:=dmy+' ';
  lbx_clone.Items.Add(dmy+' #');
  if ed_comment.Text<>'' then begin
   usr_cmt:=true;
   dmy:='# '+ed_comment.Text;
   while length (dmy) <62 do dmy:=dmy+' ';
   lbx_clone.Items.Add(dmy+' #');
  end
  else usr_cmt:=false;
  if cmd_check('getserialno') then begin
   dmy:=smc_cmd_v2('','getserialno',CAxis,1); sleep (30);
   dmy:='# Serialnumber of the SMC-Controller: '+dmy;
   while length (dmy) <62 do dmy:=dmy+' ';
   lbx_clone.Items.Add(dmy+' #');
  end;
  dmy:=smc_cmd_v2('','nidentify',CAxis,1); sleep (30);
  dmy:='# Type of the SMC-Controller: '+dmy;
  while length (dmy) <62 do dmy:=dmy+' ';
  lbx_clone.Items.Add(dmy+' #');
  if cmd_check('getnoptions') then begin
   dmy:=smc_cmd_v2('','getnoptions',CAxis,1);  sleep (30);
   if dmy ='' then begin
    dmy:=smc_cmd_v2('','getoptions',CAxis,1);  sleep (30);
   end;
   dmy:='# Options of the SMC-Controller: '+dmy;
   while length (dmy) <62 do dmy:=dmy+' ';
   lbx_clone.Items.Add(dmy+' #');
  end;
  dmy:='# Scale factor: '+FormatFloat('0.000000000',sc_fac[CAxis]);
  dmy:=StringReplace(dmy,',','.',[rfReplaceAll]);
  while length (dmy) <62 do dmy:=dmy+' ';
  lbx_clone.Items.Add(dmy+' #');
  lbx_clone.Items.Add(c_line);
  ii:=0;
  Timer1.Enabled:=true;
end;

procedure Tf_mkclone.btn_stopClick(Sender: TObject);
begin
 Timer1.Enabled:=false;
 btn_save.Enabled:=false;
 btn_crt.Enabled:=true;
 btn_close.Enabled:=true;
 btn_stop.Enabled:=false;
 ed_comment.Enabled:=true;
end;

initialization
  {$I u_createclone.lrs}

end.

