{***************************************************************************
 *   Copyright (C) 2008-2013 by Bernhard Gross                             *
 *   B.Gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        * 
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_dbg;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Dialogs;
  function dbg_file_open:boolean;
  function dbg_file_close: boolean;
  Procedure dbg_writeto_file (ettmr,u:string);
var dbgf:textfile;
    dbg_wrt,dbg_rdy,tm_stmp:boolean;
implementation

function dbg_file_open: boolean;
var err:integer;
begin
 AssignFile(dbgf,'debug.txt');
 {$I-}
  rewrite (dbgf);
 {$I+}
 err:=ioresult;
 if err<>0 then ShowMessage('Error creating "debug.txt": '+IntToStr(err));
 dbg_rdy:=err=0;
 dbg_file_open:=err=0;
end;

function dbg_file_close: boolean;
begin
 if dbg_rdy=true then begin
  dbg_rdy:=false;
  Flush(dbgf);
  sleep (30);
  CloseFile (dbgf);
  dbg_file_close:=true;
 end
 else dbg_file_close:=false;
end;

procedure dbg_writeto_file(ettmr,u: string);
var s,t:string;
begin
  if dbg_rdy and dbg_wrt then begin
  s:='';  t:='';
  if tm_stmp then begin
   t:=StringReplace(ettmr,',','.',[rfReplaceAll]);
   while Length(t)<11 do t:='0'+t;
   t:=t+'   ';
  end;
  s:=t+u;
  writeln (dbgf,s);
 end;
end;

begin
 dbg_wrt:=false;
 dbg_rdy:=false;
 tm_stmp:=true;
end.

