{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_delay;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls, u_exchange, LMessages;

type

  { Tf_delay }

  Tf_delay = class(TForm)
    btn_skip: TBitBtn;
    btn_stop: TBitBtn;
    lbl_time: TLabel;
    Timer1: TTimer;
    procedure btn_skipClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_delay: Tf_delay;

implementation

{ Tf_delay }

procedure Tf_delay.btn_stopClick(Sender: TObject);
begin
  abreak:=true;
  Timer1.Enabled:=false;
  close;
end;

procedure Tf_delay.FormClose(Sender: TObject);
begin
 Timer1.Enabled:=false;
end;

procedure Tf_delay.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
  if Msg.CharCode=27 then btn_stopClick (nil);
end;

procedure Tf_delay.FormShow(Sender: TObject);
begin
  {$IFDEF LINUX}
    btn_skip.Color:=cllime;
    btn_stop.Color:=cllime;
    btn_skip.Color:=clTeal;
    btn_stop.Color:=clTeal;
  {$ENDIF}
  lbl_time.Caption:= 'Wait for '+IntToStr(dl)+' seconds';
  if dl>0 then Timer1.Enabled:=true else close;
end;

procedure Tf_delay.Timer1Timer(Sender: TObject);
begin
  if dl>0 then dec (dl) else dl:=0;
  if dl=0 then begin
   Timer1.Enabled:=false;
   abreak:=false;
   close;
  end
  else lbl_time.Caption:= 'Wait for '+IntToStr(dl)+' Seconds';
end;

procedure Tf_delay.btn_skipClick(Sender: TObject);
begin
 abreak:=false;
 Timer1.Enabled:=false;
 close;
end;

initialization
  {$I u_delay.lrs}

end.

