{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_dlclone;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ComCtrls, u_talktosmc,ExtCtrls, CheckLst,u_exchange;

type

  { Tf_dlclone }

  Tf_dlclone = class(TForm)
    btn_close: TBitBtn;
    btn_down: TBitBtn;
    btn_stop: TBitBtn;
    cbx_all: TCheckBox;
    lb_selaxis: TLabel;
    lx_cmds: TCheckListBox;
    lb_error: TLabel;
    ProgressBar1: TProgressBar;   
    procedure cbx_allClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure btn_downClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    err,err_old:integer;
    abbr:boolean;
    cnt,crrt:integer;
    ccfvers,set_sf:double;
    s_err,s_gsp:string;
    SetCmd_Lst:TStringList;
    procedure create_list;
    procedure low_values(ax: integer);
    procedure make_error_check;
    procedure send_it;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_dlclone: Tf_dlclone;

implementation

{ Tf_dlclone }

procedure Tf_dlclone.create_list;
var i:Integer;
    s:string;
begin
 SetCmd_Lst.Clear;
 for i:=0 to lx_cmds.Items.Count-1 do begin
  s:=lx_cmds.Items[i];
  if s[1]<>'#' then begin
   SetCmd_Lst.add (s+'&'+IntToStr(i));
   if cbx_all.Checked=false then SetCmd_Lst.add ('% gne');
   if cbx_all.Checked=false then SetCmd_Lst.add ('% ngsp');
   if cbx_all.Checked=false then SetCmd_Lst.add ('# % nclear');
  end;
 end;
 if cbx_all.Checked then s:='-65535' else s:=IntToStr(CAxis);
 for i:=0 to SetCmd_Lst.Count-1 do SetCmd_Lst[i]:= StringReplace(SetCmd_Lst[i],'%',s,[rfReplaceAll]);
end;

procedure Tf_dlclone.low_values (ax:integer);
begin
 //To prevent an errormessage
 if pos ('pollux',ctrl_ident)>0 then begin
  smc_cmd_v2('1.0','snv',ax,0); sleep (25);
  smc_cmd_v2('10.0','sna',ax,0); sleep (25);
  smc_cmd_v2('0.5 1','setncalvel',ax,0); sleep (25);
  smc_cmd_v2('0.25 2','setncalvel',ax,0); sleep (25);
  smc_cmd_v2('0.5 1','setnrmvel',ax,0); sleep (25);
  smc_cmd_v2('0.25 2','setnrmvel',ax,0); sleep (25);
 end;
end;

procedure Tf_dlclone.btn_downClick(Sender: TObject);
var i:integer;
begin
 cnt:=0;err:=0; err_old:=0; abbr:=false;
 cbx_all.Enabled:=false;
 ProgressBar1.Position:=0;
 if cbx_all.Checked then low_values(-65535)else low_values(CAxis);
 lb_error.Caption:='CFG-Errors = '+IntToStr(err);
 if err<>0 then lb_error.Color:=clRed else lb_error.Color:=clLime;
 for i:=0 to lx_cmds.Items.Count-1 do lx_cmds.Checked[i]:=false;
 create_list;
 lx_cmds.ItemIndex:=0;
 lx_cmds.TopIndex:=0;
 if cbx_all.Checked then  begin
  for i:=1 to 16 do if smc_avail[i] then smc_cmd_v2('','gne',i,1);
 end
 else smc_cmd_v2('','gne',CAxis,1);
 if cbx_all.Checked then smc_cmd_v2('','nclear',-65535,0)else smc_cmd_v2('','nclear',CAxis,0);
 btn_down.Enabled:=false;
 btn_stop.Enabled:=true;
 btn_close.Enabled:=false;
 send_it;
end;

procedure Tf_dlclone.make_error_check;
var i:integer;
begin
 for i:=1 to 16 do begin
  if smc_avail[i] then begin
   smc_cmd_v2('','gne',i,1);
   if trim (smc_ans)<>'0' then Inc(err);
   sleep (pollingtime);
  end;
  if smc_avail[i] then begin
   smc_cmd_v2('','ngsp',i,1);
   if trim (smc_ans)<>'0' then begin
    Inc(err);
    smc_cmd_v2('','nclear',i,0);
    sleep (pollingtime);
   end;
   sleep (pollingtime);
  end;
 end;
 lb_error.Caption:='CFG-Errors = '+IntToStr(err);
 if err<>0 then lb_error.Color:=clRed else lb_error.Color:=clLime;
 sleep (500);
 Application.ProcessMessages;
end;


procedure Tf_dlclone.send_it;
var s,t,u:string;
    ierr,ii,jj:integer;
begin
 while (abbr=false) and (setCmd_Lst.Count>cnt) do begin
  while (pos('#',SetCmd_Lst[cnt])=1) and (cnt<SetCmd_Lst.Count-1) do inc (cnt);
  s:=SetCmd_Lst[cnt];
  if pos('&',s)>0 then begin
   t:=copy (s,pos('&',s)+1,3);
   s:=copy (s,1,pos('&',s)-1);
   val (t,crrt,ierr);
   s_err:=''; s_gsp:='';
   jj:=lx_cmds.ItemIndex;
   for ii:= jj to crrt do begin
    lx_cmds.ItemIndex:=ii;
    if pos ('#',lx_cmds.Items[ii])=1 then lx_cmds.Checked[ii]:=true;
    if (ii>3) and (lx_cmds.Items.Count-9>ii) then lx_cmds.TopIndex:=ii-3;
    if cnt<lx_cmds.Items.Count then lx_cmds.ItemIndex:=ii;
    ProgressBar1.Position:=ii;
    Application.ProcessMessages;
    sleep (50);
   end;
  end;
  if pos ('#',s)=0 then begin
   cmd_check (s);
   smc_cmd_v2(s,'',0,smc_return);
   sleep (pollingtime);
  end;
  if pos (' gne',s)>0 then s_err:=trim (smc_ans);
  if pos (' ngsp',s)>0 then s_gsp:=trim (smc_ans);
  if (pos (' ngsp',s)>0) and (s_gsp<>'0') then begin
   u:=SetCmd_Lst[cnt+1]; //Parameter left on stack, make clear
   delete (u,1,1);
   SetCmd_Lst[cnt+1]:=trim (u);
  end;
  if ((s_err='0') and (s_gsp='0')) or (cbx_all.Checked=true) then lx_cmds.Checked[crrt]:=true;
  if ((s_err<>'') and (s_gsp<>''))and ((s_err<>'0') or (s_gsp<>'0')) then begin
   lx_cmds.Checked[crrt]:=false;
   inc (err);
   lb_error.Caption:='CFG-Errors = '+IntToStr(err);
   if err<>0 then lb_error.Color:=clRed else lb_error.Color:=clLime;
   Application.ProcessMessages;
   s_err:=''; s_gsp:='';
  end;
  inc (cnt);
 end;
 if abbr=false then  begin
  if cbx_all.Checked then begin
   f_dlclone.Cursor:=crHourGlass;
   make_error_check;
   f_dlclone.Cursor:=crDefault;
  end;
  for ii:=lx_cmds.ItemIndex to lx_cmds.Items.Count-1 do begin
   if pos ('#',lx_cmds.Items[ii])=1 then lx_cmds.Checked[ii]:=true;
  end;
  lx_cmds.ItemIndex:=lx_cmds.Items.Count-1;
  ProgressBar1.Position:=lx_cmds.Items.Count;
  if set_sf>0 then begin
   if cbx_all.Checked then begin
    for ii:=1 to 16 do if smc_avail [ii] then sc_fac[ii]:=set_sf;
   end
   else sc_fac[CAxis]:=set_sf;
  end;
  btn_stop.Enabled:=false;
  Application.ProcessMessages;
  if MessageDlg ('Question:','Save clone-parameters to the SMC?', mtConfirmation,[mbYes, mbNo],0) = mrYes then begin
   f_dlclone.Cursor:=crHourGlass;
   cmd_check('nsave');
   if cbx_all.Checked then smc_cmd_v2('','nsave',-65535,0) else  smc_cmd_v2('','nsave',CAxis,0);
   sleep (smc_timeout);
   f_dlclone.Cursor:=crDefault;
  end;
   btn_down.Enabled:=true;
   btn_close.Enabled:=true;
   cbx_all.Enabled:=true;
 end;
end;

procedure Tf_dlclone.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 Setcmd_Lst.free;
end;

procedure Tf_dlclone.cbx_allClick(Sender: TObject);
begin
 lb_selaxis.Visible:=not cbx_all.Checked;
end;

procedure Tf_dlclone.btn_stopClick(Sender: TObject);
begin
  abbr:=true;
  btn_stop.Enabled:=false;
  btn_down.Enabled:=true;
  btn_close.Enabled:=true;
  cbx_all.Enabled:=true;
end;

procedure Tf_dlclone.FormShow(Sender: TObject);
var s:string;
    ierr,i:byte;
begin
  ccfvers:=00; set_sf:=-1.0; //Scale factor settings
  cbx_all.Checked:=false;
  cbx_all.Enabled:=(smc_count>1) and (diff_ctrl=false);
  lb_selaxis.Visible:=true;
  lb_selaxis.Caption:='Download to axis: '+IntToStr(CAxis);
  btn_down.Enabled:=true;
  btn_stop.Enabled:=false;
  abbr:=false;
  ProgressBar1.Color:=clgray;
  ProgressBar1.Color:=clLime;
  ProgressBar1.Position:=0;
  ProgressBar1.Max:=lx_cmds.Items.Count;
  lb_error.Color:=clLime;
  lb_error.Caption:='CFG-Errors = 0';
  s_err:=''; s_gsp:=''; crrt:=0;
  cbx_all.ShowHint:=bshowhint;
  lx_cmds.ShowHint:=bshowhint;
  lx_cmds.TopIndex:=0;
  lx_cmds.ItemIndex:=0;
  Setcmd_Lst:=TStringList.Create;
  if pos ('pollux',ctrl_ident)>0 then begin
   s:=copy (lx_cmds.Items[2],11,4);
   val (s,ccfvers,ierr);
   if ierr<>0 then ccfvers:=-1.0;
  end;
  if ccfvers>=0.27 then begin
   s:='';
   for i:=0 to 10 do if pos ('# Scale factor: ',lx_cmds.Items[i])=1 then s:=lx_cmds.Items[i];
   if s<>'' then begin
    delete (s,1,16); s:=copy (s,1,pos(' ',s)-1); //Scalefactor for Pollux
    val (s,set_sf,ierr);
    if ierr<>0 then set_sf:=-1.0;
   end;
  end;
end;

initialization
  {$I u_dlclone.lrs}

end.

