{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_editbutton;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, Spin, StdCtrls,u_exchange,LCLType;

type

  { Tf_editbutton }

  Tf_editbutton = class(TForm)
    btn_loadicon: TBitBtn;
    btn_ok: TBitBtn;
    btn_cancel: TBitBtn;
    cb_visible: TCheckBox;
    ed_cmd: TEdit;
    ed_btnline1: TEdit;
    ed_btnline2: TEdit;
    ed_btnline3: TEdit;
    ed_btnhint: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    OpenDialog1: TOpenDialog;
    spe_showaxis: TSpinEdit;
    procedure btn_loadiconClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure spe_showaxisChange(Sender: TObject);
    procedure spe_showaxisKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { private declarations }
  public
   fn:string;
   Ena:Integer;
    { public declarations }
  end; 

var
  f_editbutton: Tf_editbutton;

implementation

{ Tf_editbutton }

procedure Tf_editbutton.btn_loadiconClick(Sender: TObject);
begin
 OpenDialog1.InitialDir:=ProgramDir+DirSep+'usertableau';
 OpenDialog1.Filter:='Bitmap-Files (*.bmp)|*.bmp';
 OpenDialog1.DefaultExt:='.bmp';
 if OpenDialog1.Execute then begin
  if (OpenDialog1.FileName<>OpenDialog1.InitialDir)and (FileExists(OpenDialog1.FileName)) then begin
   fn:=copy (OpenDialog1.FileName,Length(ProgramDir)+2,Length(OpenDialog1.FileName)-Length(ProgramDir));
   Image1.Picture.Clear;
   Image1.Picture.LoadFromFile(fn);
  end;
 end;
end;


procedure Tf_editbutton.FormShow(Sender: TObject);
begin
  {$IFDEF WINDOWS}
    ed_btnline2.Enabled:=false;
    ed_btnline3.Enabled:=false;
  {$ENDIF}
  If FileExists(fn) then Image1.Picture.LoadFromFile(fn) else Image1.Picture.Clear;
end;

procedure Tf_editbutton.spe_showaxisChange(Sender: TObject);
begin

end;

procedure Tf_editbutton.spe_showaxisKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_showaxis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_showaxis.Value:=nw;
   spe_showaxisChange(nil);
  end;
 end;
end;


initialization
  {$I u_editbutton.lrs}

end.

