{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_editvc2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls,u_exchange;

type

  { Tf_editvc2 }

  Tf_editvc2 = class(TForm)
    btn_cancel: TBitBtn;
    btn_ok: TBitBtn;
    btn_save: TBitBtn;
    mm_cmds: TMemo;
    SaveDialog1: TSaveDialog;
    procedure btn_saveClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_editvc2: Tf_editvc2;

implementation

{ Tf_editvc2 }

procedure Tf_editvc2.btn_saveClick(Sender: TObject);
var s:string;
begin
 if pos ('.',venusfile)>0 then s:= copy (venusfile,1,pos('.',venusfile)-1) else s:=venusfile;
 s:=ExtractFileName(s);
 SaveDialog1.FileName:= s;
 SaveDialog1.InitialDir:=ProgramDir+DirSep+'venus2';
 SaveDialog1.Filter:='Venus2-Files (*.vc2)|*.vc2';
 SaveDialog1.DefaultExt:='.vc2';
 if (SaveDialog1.Execute=true) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
  if LowerCase (ExtractFileExt(SaveDialog1.FileName)) <>'.vc2' then SaveDialog1.FileName:=SaveDialog1.FileName+'.vc2';
  mm_cmds.Lines.SaveToFile(SaveDialog1.FileName);
  venusfile:=SaveDialog1.FileName;
 end;
end;


initialization
  {$I u_editvc2.lrs}

end.

