{***************************************************************************
 *   Copyright (C) 2012-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}    
 
unit u_handwheel;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Spin, Buttons, types, u_talktosmc, u_exchange, LMessages;

type

  { Tf_handwheel }

  Tf_handwheel = class(TForm)
    btn_close: TBitBtn;
    btn_stopall: TBitBtn;
    fle_dist: TFloatSpinEdit;
    Image1: TImage;
    lb_next: TLabel;
    procedure btn_closeClick(Sender: TObject);
    procedure btn_stopallClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Image1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Image1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);

  private
    { private declarations }
  public
  procedure showIt;
    { public declarations }
  end;

var
  f_handwheel: Tf_handwheel;

implementation

{ Tf_handwheel }

procedure Tf_handwheel.showIt;
begin
 if hwmv=0 then lb_next.Color:=clLime else lb_next.Color:=clRed;
end;

procedure Tf_handwheel.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 showhwmd:=false;
end;

procedure Tf_handwheel.btn_stopallClick(Sender: TObject);
begin
 smc_cmd_v2(#3,'',0,0);
end;

procedure Tf_handwheel.btn_closeClick(Sender: TObject);
begin
 smc_cmd_v2(#3,'',0,0);
 close;
end;

procedure Tf_handwheel.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
 if Msg.CharCode=27 then btn_stopallClick (nil);
end;

procedure Tf_handwheel.FormShow(Sender: TObject);
begin
 showhwmd:=true;
 hwmv:=0;
 Image1.ShowHint:=bshowhint;
 fle_dist.ShowHint:=bshowhint;
 lb_next.ShowHint:=bshowhint;
end;

procedure Tf_handwheel.Image1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
 if hwmv =0 then begin
  hwmv:=1; hwcnt:=0;
  smc_cmd_v2 (FormatFloat('0.000000',fle_dist.Value/sc_fac[CAxis]*-1),'nr',CAxis,0);
 end;
end;

procedure Tf_handwheel.Image1MouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
 if hwmv =0 then begin
  hwmv:=1; hwcnt:=0;
  smc_cmd_v2 (FormatFloat('0.000000',fle_dist.Value/sc_fac[CAxis]),'nr',CAxis,0);
 end;
end;

initialization
  {$I u_handwheel.lrs}

end.

