{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus, StdCtrls,LCLType,
  Buttons, Spin,ExtCtrls, u_about, u_port,u_export_cfg, u_talktosmc, u_exchange, u_showcon, math,
  u_waittime, u_calc, u_chginc, u_venus, u_options, u_update, u_license, u_thanks,u_vc2help, u_usrbtn,
  u_scalefactors, u_systemunit,u_createclone,u_dlclone,u_dbg,u_dbgbtn,u_unknown_ctrl,u_cfg_uservar,u_cfg_powerup,
  u_cfg_stages,u_cfg_cl,u_cldiag,u_upgrade,u_speedmode,u_cfg_dynamic_parm,u_handwheel, EpikTimer;
  
type
  obj_parm=^Segment;
   Segment= Record
    l,w,t,h: Word;
    next: obj_parm;
   end;

  { Tf_main }

  Tf_main = class(TForm)
    btn_inv: TBitBtn;
    btn_sel: TBitBtn;
    btn_desel: TBitBtn;
    btn_speedmode: TBitBtn;
    btn_rbbt: TBitBtn;
    btn_cf: TBitBtn;
    btn_gohome: TBitBtn;
    btn_def_home: TBitBtn;
    btn_nr_neg: TBitBtn;
    btn_exe: TBitBtn;
    btn_nr_pos: TBitBtn;
    btn_nm: TBitBtn;
    btn_reset: TBitBtn;
    btn_nsave: TBitBtn;
    btn_ncal: TBitBtn;
    btn_nrm: TBitBtn;
    btn_stopall: TBitBtn;
    cbx_direct: TCheckBox;
    cbx_debug: TCheckBox;
    chg_axis: TCheckGroup;
    ed_rbbtcmd: TEdit;
    ed_command: TEdit;
    fle_target: TFloatSpinEdit;
    ed_spd_stps: TLabeledEdit;
    gbx_multi_axis: TGroupBox;
    gbx_spdmd: TGroupBox;
    lb_alive: TLabel;
    lb_sd: TLabel;
    lb_pos: TLabel;
    lb_clerr: TLabel;
    lb_scalefac: TLabel;
    lb_clwdw: TLabel;
    lb_move: TLabel;
    lb_available: TLabel;
    lb_E1: TLabel;
    lb_E2: TLabel;
    lb_unit: TLabel;
    lbx_hist: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    mi_alive: TMenuItem;
    mi_ws_stdd: TMenuItem;
    mi_ws_cm: TMenuItem;
    mi_ws_cs: TMenuItem;
    MenuItem17: TMenuItem;
    mi_ws_save: TMenuItem;
    MenuItem8: TMenuItem;
    mi_wheel: TMenuItem;
    mi_cldiag: TMenuItem;
    mi_usrvar: TMenuItem;
    mi_powerup: TMenuItem;
    mi_cloop: TMenuItem;
    mi_stage: TMenuItem;
    mi_dynp: TMenuItem;
    mi_dlclone: TMenuItem;
    MenuItem3: TMenuItem;
    mi_upgrade: TMenuItem;
    MenuItem6: TMenuItem;
    mi_debug: TMenuItem;
    mi_crclone: TMenuItem;
    mi_rescan: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem23: TMenuItem;
    mi_port: TMenuItem;
    MenuItem5: TMenuItem;
    mi_connect: TMenuItem;
    mi_discnnt: TMenuItem;
    mi_commun: TMenuItem;
    mi_stop_old: TMenuItem;
    mi_file: TMenuItem;
    mi_close: TMenuItem;
    mi_help: TMenuItem;
    mi_settings: TMenuItem;
    mi_smc: TMenuItem;
    mi_showhints: TMenuItem;
    mi_about: TMenuItem;
    mi_options: TMenuItem;
    mi_savecfg: TMenuItem;
    mi_readcfg: TMenuItem;
    MenuItem24: TMenuItem;
    mi_license: TMenuItem;
    mi_thanks: TMenuItem;
    Panel1: TPanel;
    pmi_save: TMenuItem;
    MenuItem29: TMenuItem;
    mi_download: TMenuItem;
    mi_stop: TMenuItem;
    MenuItem31: TMenuItem;
    mi_editinc: TMenuItem;
    mi_special: TMenuItem;
    mi_update: TMenuItem;
    mi_vc2help: TMenuItem;
    mi_usrtableau: TMenuItem;
    mi_scalefactor: TMenuItem;
    mi_systemunits:TMenuItem;
    mi_openvc2: TMenuItem;
    mi_export: TMenuItem;
    mi_calc: TMenuItem;
    MenuItem7: TMenuItem;
    pmi_clear: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    SaveDialog1: TSaveDialog;
    btn_connect: TSpeedButton;
    btn_disconnect: TSpeedButton;
    btn_rescan: TSpeedButton;
    btn_vc2: TSpeedButton;
    btn_utb: TSpeedButton;
    btn_close: TSpeedButton;
    spe_axis: TSpinEdit;
    Timer1: TTimer;
    procedure btn_invClick(Sender: TObject);
    procedure btn_selClick(Sender: TObject);
    procedure btn_deselClick(Sender: TObject);
    procedure btn_rbbtClick(Sender: TObject);
    procedure btn_speedmodeClick(Sender: TObject);
    procedure cbx_debugChange(Sender: TObject);
    procedure chg_axisItemClick(Sender: TObject);
    procedure ed_commandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ed_commandKeyPress(Sender: TObject; var Key: char);
    procedure ed_rbbtcmdKeyPress(Sender: TObject; var Key: char);
    procedure ed_spd_stpsChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lbx_histDblClick(Sender: TObject);
    procedure mi_aliveClick(Sender: TObject);
    procedure mi_settingsClick(Sender: TObject);
    procedure mi_upgradeClick(Sender: TObject);
    procedure mi_cldiagClick(Sender: TObject);
    procedure mi_usrvarClick(Sender: TObject);
    procedure mi_cloopClick(Sender: TObject);
    procedure mi_dlcloneClick(Sender: TObject);
    procedure mi_crcloneClick(Sender: TObject);
    procedure mi_debugClick(Sender: TObject);
    procedure mi_dynpClick(Sender: TObject);
    procedure mi_powerupClick(Sender: TObject);
    procedure mi_stageClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure mi_systemunitsClick(Sender: TObject);
    procedure btn_cfClick(Sender: TObject);
    procedure btn_def_homeClick(Sender: TObject);
    procedure btn_rescanClick(Sender: TObject);
    procedure lb_clerrDblClick(Sender: TObject);
    procedure mi_vc2helpClick(Sender: TObject);
    procedure mi_usrtableauClick(Sender: TObject);
    procedure mi_scalefactorClick(Sender: TObject);
    procedure btn_exeClick(Sender: TObject);
    procedure btn_gohomeClick(Sender: TObject);
    procedure btn_nr_negClick(Sender: TObject);
    procedure btn_nr_posClick(Sender: TObject);
    procedure btn_nmClick(Sender: TObject);
    procedure btn_resetClick(Sender: TObject);
    procedure btn_nsaveClick(Sender: TObject);
    procedure btn_ncalClick(Sender: TObject);
    procedure btn_nrmClick(Sender: TObject);
    procedure btn_stopallClick(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mi_closeClick(Sender: TObject);
    procedure mi_showhintsClick(Sender: TObject);
    procedure mi_aboutClick(Sender: TObject);
    procedure mi_portClick(Sender: TObject);
    procedure mi_optionsClick(Sender: TObject);
    procedure mi_savecfgClick(Sender: TObject);
    procedure mi_connectClick(Sender: TObject);
    procedure mi_discnntClick(Sender: TObject);
    procedure mi_readcfgClick(Sender: TObject);
    procedure mi_licenseClick(Sender: TObject);
    procedure mi_thanksClick(Sender: TObject);
    procedure mi_wheelClick(Sender: TObject);
    procedure mi_ws_cmClick(Sender: TObject);
    procedure mi_ws_saveClick(Sender: TObject);
    procedure mi_ws_stddClick(Sender: TObject);
    procedure pmi_saveClick(Sender: TObject);
    procedure mi_stopClick(Sender: TObject);
    procedure mi_editincClick(Sender: TObject);
    procedure mi_updateClick(Sender: TObject);
    procedure mi_downloadClick(Sender: TObject);
    procedure mi_openvc2Click(Sender: TObject);
    procedure mi_exportClick(Sender: TObject);
    procedure mi_calcClick(Sender: TObject);
    procedure pmi_clearClick(Sender: TObject);
    procedure PopupMenu3Popup(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);


  private
    { private declarations }
    frm_old:TPoint;
    o_scalex,o_scaley:double;
    first,last:obj_parm;
    first_obj:Boolean;
    whatread:byte;
    cmd_idx,f_sx,f_sy:Integer;
    procedure button_status;
    procedure chk_merror;
    procedure exec_cmd (excmd:string;src:integer);
    procedure input_new(new_obj: obj_parm);
    function outstr (cmd:string):string;
    procedure ctrl_cl;
    function read_limitsw: boolean;
    function read_position: boolean;
    procedure read_serialno;
    procedure ScaleIt;
    procedure showhist(s: string);
    procedure show_hints;
    procedure showscalefactor;
    procedure unknown_ctrl;
    function read_status:boolean;
  public
    { public declarations }
  end; 

var
  f_main: Tf_main;

implementation

{ Tf_main }

procedure Tf_main.showhist (s:string);
begin
 s:=StringReplace(s,',','.',[rfReplaceAll]);
 lbx_hist.Items.Add (s);
 while (lbx_hist.Count>100) do lbx_hist.Items.Delete(0);
 if lbx_hist.items.Count>8 then lbx_hist.TopIndex:=lbx_hist.Count-10;
 cmd_idx:=lbx_hist.Items.Count-1;
end;

procedure Tf_main.button_status;
begin
 ed_spd_stps.Enabled:=(smc_avail[spe_axis.Value]) and (smc_connect);
 mi_port.Enabled:=not comp_open;
 mi_connect.Enabled:=(not comp_open) and ((actdev<>'<<<NONE>>>') or (tcpip_select=true));
 mi_calc.Enabled:=ctrl_ident<>'hydra';
 mi_scalefactor.Enabled:=ctrl_ident<>'hydra';
 mi_discnnt.Enabled:=comp_open;
 mi_rescan.Enabled:=comp_open and (axis_moves=false);
 mi_readcfg.Enabled:=smc_connect and (axis_moves=false)and (ctrl_ident<>'hydra');
 mi_stop.Enabled:=smc_connect;
 mi_stop_old.Enabled:=smc_connect;
 mi_download.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 mi_export.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 mi_options.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false)and (pos ('pollux',ctrl_ident)>0);
 mi_update.Enabled:=true and (pos ('pollux',ctrl_ident)>0);
 mi_usrtableau.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 mi_openvc2.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 mi_vc2help.Enabled:= (FileExists(ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'vc2-help.txt')) and smc_connect;
 mi_dlclone.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false)and (ctrl_ident<>'hydra');
 mi_crclone.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 mi_cldiag.Enabled:=acl_ctrl [spe_axis.Value] and smc_connect and (axis_moves=false) and (ctrl_ident='pollux-nt');
 mi_upgrade.Enabled:=smc_connect and smc_avail[spe_axis.Value] and (pos ('pollux',ctrl_ident)>0);
 mi_dynp.Enabled:=smc_connect and smc_avail[spe_axis.Value];
 mi_stage.Enabled:=smc_connect and smc_avail[spe_axis.Value];
 mi_cloop.Enabled:=smc_connect and smc_avail[spe_axis.Value] and (ctrl_ident='pollux-nt');
 mi_powerup.Enabled:=smc_connect and smc_avail[spe_axis.Value] and  (ctrl_ident<>'hydra');
 mi_usrvar.Enabled:=smc_connect and smc_avail[spe_axis.Value] and  (pos ('pollux',ctrl_ident)>0);
 mi_wheel.Enabled:=(smc_avail[spe_axis.Value]) and (smc_connect);
 btn_cf.Visible:=smc_avail[spe_axis.Value] and smc_connect and (acl_ctrl [spe_axis.Value])or (ctrl_ident='hydra');
 btn_close.Enabled:=axis_moves=false;
 btn_connect.Enabled:=(not comp_open) and ((actdev<>'<<<NONE>>>') or (tcpip_select=true));
 btn_connect.visible:=not comp_open;
 btn_def_home.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_disconnect.visible:=comp_open;
 btn_disconnect.Enabled:=comp_open and (axis_moves=false);
 btn_exe.Enabled:=smc_connect;
 btn_gohome.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_ncal.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_nm.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_nr_neg.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_nr_pos.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_nrm.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_nsave.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_rescan.Visible:=comp_open;
 btn_rescan.Enabled:=comp_open and (axis_moves=false);
 btn_reset.Enabled:=smc_avail[spe_axis.Value] and smc_connect;
 btn_speedmode.Enabled:=(smc_avail[spe_axis.Value]) and (smc_connect) and (spdwin_open=false);
 btn_stopall.Enabled:=smc_connect;
 btn_utb.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_utb.visible:=smc_avail[spe_axis.Value] and smc_connect;
 btn_vc2.Enabled:=smc_avail[spe_axis.Value] and smc_connect and (axis_moves=false);
 btn_vc2.visible:=smc_avail[spe_axis.Value] and smc_connect;
 ed_command.Enabled:=smc_connect;
 fle_target.Enabled:=smc_avail[spe_axis.Value] and smc_connect;
 lb_alive.Visible:=smc_connect and mi_alive.Checked;
 lb_E1.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 lb_E2.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 lb_move.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 lb_unit.Caption:=actunit[spe_axis.Value];
 lb_unit.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 lb_clwdw.Visible:=smc_avail[spe_axis.Value] and smc_connect and (acl_ctrl [spe_axis.Value])or (ctrl_ident='hydra');
 lb_clerr.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 lb_pos.Visible:=smc_avail[spe_axis.Value] and smc_connect;
 cbx_direct.Enabled:=smc_connect;
 spe_axis.Enabled:=smc_connect and (smc_count>1);
 gbx_multi_axis.Enabled:=smc_connect and (smc_count>1)and (ctrl_ident<>'hydra');
 gbx_spdmd.Enabled:=smc_connect;
 Timer1.Enabled:=smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.showscalefactor;
begin
 if sc_fac[spe_axis.Value]=1 then lb_scalefac.color:=clLime else lb_scalefac.color:=clRed;
 fle_target.MinValue:=sc_fac[spe_axis.Value]*-1000;
 fle_target.MaxValue:=sc_fac[spe_axis.Value]*1000;
 lb_scalefac.Caption:='Scalefactor= '+FormatFloat('0.0000000000',sc_fac[spe_axis.Value]);
end;

procedure Tf_main.exec_cmd (excmd:string;src:integer);
var ans,snd:string;
    i,ax:integer;
    btimer:boolean;
begin
  excmd:=trim(excmd);
  if (excmd<>'') and (smc_cmd_active=false) and (smc_connect=true) then begin
  btimer:= Timer1.Enabled;
  sleep (50);
  smc_cmd_active:=true;
  i:=0; ax:=0;
  if pos ('setncode',excmd)=0 then begin
   excmd:= Trim(excmd);
   excmd:=StringReplace(excmd,',','.',[rfReplaceAll]);
   while (i<length(excmd)) and not(excmd[i] in ['A'..'z']) do inc (i);
   if (i>0) and (excmd[i-1]<>' ')  then insert (' ',excmd,i);
   excmd:=StringReplace(excmd,'  ',' ',[rfReplaceAll]);
  end
  else begin
   showmessage ('To enable the new option:'+#13+'[axisno] nsave'+#13+'[axisno] nreset');
  end;
  if cbx_direct.Checked then begin
   snd:=excmd;
   if cmd_check(excmd)=false then smc_return:=1;
  end
  else cmd_check(excmd);
  if smc_cmd<>'' then snd:=smc_cmd;
  if snd<>'' then begin
   excmd:=copy (excmd,1,Length(excmd)-Length(snd))+snd;
   if src=1 then ed_command.Text:= trim(excmd);
   showhist (Trim(excmd));
   Timer1.Enabled:=false;
   ans:=smc_cmd_v2(excmd,'',0,smc_return);
   if (pos('reset',smc_cmd)=1) and (tcpip_select) then begin
    showhist ('  Temporary disconnected by RESET!');
    smc_close;
   end;
   if smc_return>0 then showhist ('   '+ans);
   if smc_cmdtout> 0 then begin
    f_waittime.Caption:='SMC-Timeout by the last command';
    f_waittime.Show;
    f_waittime.pgb_time.Color:=cllime;
    for i:= 1 to 100 do begin
     sleep(smc_cmdtout*10);
     f_waittime.pgb_time.Position:=i;
     Application.ProcessMessages;
    end;
    f_waittime.Close;
   end;
   if (pos('reset',smc_cmd)=1) and (tcpip_select) then smc_open;
   if 'setaxisno'=smc_cmd then begin
   if pos (' setaxisno',excmd)=0 then insert (' ',excmd,pos ('setaxisno',excmd));
    excmd:= trim (copy (excmd,1,pos (' ',excmd)-1));
    TryStrToInt(excmd,ax);
    if ax in [1..16] then begin
     spdcur[ax]:=spdcur[CAxis];
     spdcur[CAxis]:=-1;
     spe_axis.MinValue:=ax;
     spe_axis.MaxValue:=ax;
     spe_axis.Value:=ax;
     CAxis:=ax;
     LowAxisNo:=ax;
     HighAxisNo:=ax;
     for i:=1 to 16 do smc_avail[i]:=false;
     smc_avail[ax]:=true;
     ctrl_cl;
    end;
   end;
  sleep (50);
  Timer1.Enabled:=btimer;
  end;
 end;
 if spdwin_open then begin
  if ((smc_cmd='snv')or(smc_cmd='setnvel')or(smc_cmd='nreset')or(smc_cmd='nrestore')or(smc_cmd='getnfpara')
  or(smc_cmd='setpitch')) then begin
   f_speedmode.get_maxvel;
   f_speedmode.show_vel;
  end;
 end;
 smc_cmd_active:=false;
 if src=1 then ed_command.SelectAll else if src=2 then ed_rbbtcmd.SelectAll;
end;

function Tf_main.outstr (cmd:string): string;
var wrk,s_axis,s,erg:string;
    v,i:integer;
    be_str:boolean;
begin
 s_axis:=IntToStr(spe_axis.Value);
 If pos('Settings for Axis',cmd)>0 then cmd:=cmd+'  Current axis-No.: '+s_axis;
 v:=0;
 wrk:='';
 if pos ('{',cmd) >0 then  wrk:= copy (cmd,pos('{',cmd)+1,pos('}',cmd)-pos('{',cmd)-1);
 if (pos ('#',wrk)> 0) and (wrk<>'') then begin
   Insert(s_axis,wrk,pos('#',wrk));
   delete (wrk,pos('#',wrk),1);
 end;
 if wrk<>'' then begin
  s:=smc_cmd_v2(wrk,'',0,1);be_str:=ans_be_str;
  s:=trim (s);
  if (s='') and (be_str=false) then s:='###';
  if pos ('getserialno',wrk)>0 then actserialno:=s;

  if pos ('&',cmd)>0 then begin
   v:=StrToInt(cmd[pos ('&',cmd)+1]);
  end;
  if v>0 then begin
  for i:=1 to v do begin
   s:=trim (s);
   if pos (' ',s)>0 then erg:= trim (copy (s,1,pos(' ',s)-1)) else erg:=s;
   if pos (' ',s)>0 then delete (s,1,pos (' ',s));
  end;
  s:=erg;
  end;
 end;
 erg:=cmd;
 delete (erg,pos('[',erg),1);
 delete (erg,pos(']',erg),1);
 if pos ('{',erg)>0 then begin
  delete (erg,pos ('{',erg),pos ('}',erg)-pos ('{',erg)+1);
  insert (s,erg,pos('&',erg));
  delete (erg,pos('&',erg),2);
  erg:=trim (erg);
 end;
 outstr:= erg;
end;

procedure Tf_main.show_hints;
begin
 btn_nr_neg.ShowHint:=mi_showhints.Checked;
 btn_nr_pos.ShowHint:=mi_showhints.Checked;
 btn_nm.ShowHint:=mi_showhints.Checked;
 btn_reset.ShowHint:=mi_showhints.Checked;
 btn_nsave.ShowHint:=mi_showhints.Checked;
 btn_ncal.ShowHint:=mi_showhints.Checked;
 btn_nrm.ShowHint:=mi_showhints.Checked;
 btn_stopall.ShowHint:=mi_showhints.Checked;
 btn_exe.ShowHint:=mi_showhints.Checked;
 btn_def_home.ShowHint:=mi_showhints.Checked;
 btn_gohome.ShowHint:=mi_showhints.Checked;
 btn_cf.ShowHint:=mi_showhints.Checked;
 btn_rescan.ShowHint:=mi_showhints.Checked;
 btn_connect.ShowHint:=mi_showhints.Checked;
 btn_disconnect.ShowHint:=mi_showhints.Checked;
 btn_close.ShowHint:=mi_showhints.Checked;
 btn_vc2.ShowHint:=mi_showhints.Checked;
 btn_speedmode.ShowHint:=mi_showhints.Checked;
 btn_utb.ShowHint:=mi_showhints.Checked;
 ed_command.ShowHint:=mi_showhints.Checked;
 lb_pos.ShowHint:=mi_showhints.Checked;
 lbx_hist.ShowHint:=mi_showhints.Checked;
 fle_target.ShowHint:=mi_showhints.Checked;
 spe_axis.ShowHint:=mi_showhints.Checked;
 lb_alive.ShowHint:=mi_showhints.Checked;
 lb_move.ShowHint:=mi_showhints.Checked;
 lb_E1.ShowHint:=mi_showhints.Checked;
 lb_E2.ShowHint:=mi_showhints.Checked;
 lb_unit.ShowHint:=mi_showhints.Checked;
 lb_scalefac.ShowHint:=mi_showhints.Checked;
 lb_clerr.ShowHint:=mi_showhints.Checked;
 cbx_direct.ShowHint:=mi_showhints.Checked;
 bshowhint:=mi_showhints.Checked;
 ed_rbbtcmd.ShowHint:=mi_showhints.Checked;
 btn_rbbt.ShowHint:=mi_showhints.Checked;
 chg_axis.ShowHint:=mi_showhints.Checked;
 btn_sel.ShowHint:=mi_showhints.Checked;
 btn_inv.ShowHint:=mi_showhints.Checked;
 btn_desel.ShowHint:=mi_showhints.Checked;
 Panel1.ShowHint:=mi_showhints.Checked;
 ShowHint:=mi_showhints.Checked;
end;

procedure Tf_main.unknown_ctrl;
begin
 if MessageDlg ('Question', 'The controller is unknown! Continue?', mtError,[mbYes,mbNo],0) = mrYes then begin
  if f_unknown_ctrl.ShowModal=mrCancel then begin
  if comp_open then smc_close;
   smc_count:=0;
   lb_scalefac.Visible:=false;
   lb_available.Visible:=false;
  end;
 end
 else begin
  if comp_open then smc_close;
   smc_count:=0;
   lb_scalefac.Visible:=false;
   lb_available.Visible:=false;
 end;
 button_status;
end;

procedure Tf_main.read_serialno;
var s:string;
    cnt:integer;
    old_raise:boolean;
begin
 serial_str:='';
 serial_str:=trim (smc_cmd_v2('getserialno','',0,1));
 cnt:=0; s:='';
 if tcpip_select=false then old_raise:=serl_port.RaiseExcept else old_raise:=eth_port.RaiseExcept;
 if tcpip_select=false then serl_port.RaiseExcept:=false else eth_port.RaiseExcept:=false;
 repeat
  inc (cnt);
  if tcpip_select=false then s:=serl_port.Recvstring(50) else s:=eth_port.Recvstring(50);
  Application.ProcessMessages;
 until (s='') or (cnt>25);
 if tcpip_select=false then serl_port.RaiseExcept:=old_raise else eth_port.RaiseExcept:=old_raise;
end;

procedure Tf_main.mi_connectClick (Sender: TObject);
var i,cc:Integer;
    ok:boolean;
    errmsg:string;
begin
 ok:=false;
 Last_Ctrl:=Cfg_last_Ctrl;
 for i:= 1 to 16 do acl_ctrl[i]:=false;
 btn_connect.Enabled:=false;
 mi_connect.Enabled:=false;
 f_consts.Show;
 ok:=smc_open;
 Application.ProcessMessages;
 f_consts.Close;
 if (ok=true) and (open_err=0) then begin
  if (ctrl_ident='unknown') and (smc_count>0) then unknown_ctrl;
  if (diff_ctrl=true) and (warn_diff_ctrl)and (smc_count>0) then MessageDlg ('Warning:','You are using different controllers/firmware!',mtWarning,[mbOK],0);
  if (ctrl_ident='unknown') and (smc_count=0) then f_main.Caption:='PolluxTerm: NONE@'+actdev;
  if ctrl_ident<>'unknown' then begin
    lb_available.Visible:=true;
    if VirtPollux=false then begin
      lb_available.Color:=clNone;
      if ctrl_ident='hydra' then cc:=1 else cc:=smc_count;
      lb_available.caption:='There are '+Inttostr (cc)+' SMC-Controllers available!';
      if ctrl_ident='hydra' then begin
       btn_nsave.Caption:='save';
       btn_reset.Caption:='reset';
      end;
    end
    else begin
      lb_available.Color:=clYellow;
      lb_available.caption:='There are '+Inttostr (smc_count)+' VIRTUAL Polluxes available!';
    end;
    for i:= 1 to Last_Ctrl  do if smc_avail[i] then HighAxisNo:=i;
    for i:= Last_Ctrl downto 1 do if smc_avail[i] then LowAxisNo:=i;
    if smc_count>0 then begin
     if tcpip_select then  f_main.Caption:='PolluxTerm: ' +Uppercase(ctrl_ident)+'@'+tcpip_adr+':'+tcpip_port
     else f_main.Caption:='PolluxTerm: ' +Uppercase(ctrl_ident)+'@'+actdev;
     cmdlst.LoadFromFile(ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'vc2-cmds.txt');
      spe_axis.MaxValue:=HighAxisNo;
      spe_axis.MinValue:=LowAxisNo;
      spe_axis.Value:=LowAxisNo;
      CAxis:=LowAxisNo;
      ctrl_cl;
    end;
    if smc_count>1 then begin
     ed_rbbtcmd.Enabled:=true;
     chg_axis.Enabled:=true;
     for i:= 0 to 15 do chg_axis.CheckEnabled[i]:=smc_avail[i+1];
    end
    else begin
     ed_rbbtcmd.Enabled:=false;
     btn_rbbt.Enabled:=false;
     chg_axis.Enabled:=false;
    end;
    lb_clerr.Color:= clLime; lb_clerr.Caption:='No Error';
    button_status;
    lb_scalefac.Visible:=true;
    showscalefactor;
  end;
 end
 else if open_err <>0 then begin
  errmsg:='Unknown error: '+IntToStr(open_err);
  case open_err of
   9:errmsg:= 'Port owned by other process!';
  end;
  MessageDlg ('Error:',errmsg,mtError,[mbOK],0);
  btn_connect.Enabled:=true;
  mi_connect.Enabled:=true;
 end;
 button_status;
 btn_rescan.visible:=comp_open;
 btn_disconnect.visible:=comp_open;
 if (ctrl_ident='taurus') or (ctrl_ident='pegasus') then read_serialno;
end;


procedure Tf_main.mi_discnntClick(Sender: TObject);
var i:Integer;
begin
  if smc_connect then begin
   Timer1.Enabled:=False;
   smc_cmd_v2(#3,'',0,0);
  end;
  if spdwin_open then f_speedmode.Close;
  serial_str:='';
  if smc_count>0 then cmdlst.Clear;
  if comp_open then smc_close;
  btn_rescan.visible:=comp_open;
  btn_disconnect.visible:=comp_open;
  lb_available.Visible:=false;
  lb_scalefac.Visible:=false;
  btn_rbbt.Enabled:=false;
  button_status;
  axes_rbbt:=0;
  f_main.Caption:='PolluxTerm';
  for i:=1 to 16 do smc_avail[i]:=false;
  for i:=0 to 15 do chg_axis.Checked[i]:=false;
  OpenDialog1.FileName:='';
  SaveDialog1.FileName:='';
  btn_nsave.Caption:='nsave';
  btn_reset.Caption:='nreset';
  ctrl_ident:='unknown';
  lb_sd.Visible:=false;
  button_status;
end;

procedure Tf_main.mi_readcfgClick(Sender: TObject);
begin
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_export.ShowModal;
 Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_licenseClick(Sender: TObject);
begin
  f_license.ShowModal;
end;

procedure Tf_main.mi_thanksClick(Sender: TObject);
begin
  f_thanks.ShowModal;
end;

procedure Tf_main.mi_wheelClick(Sender: TObject);
begin
 f_handwheel.Show;
end;

procedure Tf_main.mi_ws_cmClick(Sender: TObject);
begin
 f_main.Width:=f_sx;
 f_main.Height:=f_sy;
end;

procedure Tf_main.mi_ws_saveClick(Sender: TObject);
var f_size:textfile;
    sizestr:string;
begin
 sizestr:= IntToStr(f_main.Width)+'x'+IntToStr(f_main.Height);
 AssignFile(f_size,'form_size.txt'); rewrite (f_size);
 writeln (f_size,sizestr);
 CloseFile(f_size);
 mi_ws_cm.Caption:='Form_Size.txt: '+sizestr;
end;

procedure Tf_main.mi_ws_stddClick(Sender: TObject);
begin
 f_main.Width:=800;
 f_main.Height:=640;
end;

procedure Tf_main.pmi_saveClick(Sender: TObject);
begin
 SaveDialog1.InitialDir:=ProgramDir;
 SaveDialog1.FileName:='';
 SaveDialog1.Filter:='Text-Files (*.txt)|*.txt';
 SaveDialog1.DefaultExt:='.txt';
 if (SaveDialog1.Execute) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then lbx_hist.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure Tf_main.mi_closeClick(Sender: TObject);
begin
  close;
end;

procedure Tf_main.FormShow(Sender: TObject);
var f,f_size:textfile;
     s,exc,sizestr:string;
     err,i,c_last:integer;
     dbl,tg:double;
     ok:boolean;
begin
 if FileExists('form_size.txt') then begin
  AssignFile(f_size,'form_size.txt'); reset (f_size);
  readln (f_size,sizestr);
  CloseFile(f_size);
 end;
 mi_ws_cm.Caption:='Form_Size.txt: '+sizestr;
 s:= copy (sizestr,1,pos('x',sizestr)-1);
 val (s,f_sx,err);
 if err<>0 then f_sx:=800;
 s:= sizestr; delete (s,1,pos('x',s));
 val (s,f_sy,err);
 if err<>0 then f_sy:=640;
 err:=0; whatread:=0; cmd_idx:=0;
 f_main.Width:=f_sx;
 f_main.Height:=f_sy;
 f_main.Left:=0;
 f_main.Top:=0;
 ProgramDir:=GetCurrentDir;
 Rot_Unit:='°';
 {$IFDEF LINUX}
  actdev:='/dev/ttyS0';
  dirsep:='/';
 {$ENDIF}
 {$IFDEF WINDOWS}
  actdev:='COM1';
  dirsep:='\';
 {$ENDIF}
 if ctrl_parm =false then ShowMessage('Please close the program and '+#10+'check the file controller.txt');
 System_DecSep:=DecimalSeparator;
 actbaud:='19200';
 mi_showhints.Checked:=true;
 mi_alive.Checked:=true;
 Lin_Unit:='mm';
 for i:= 1 to 16 do begin
  actunit[i]:='mm';
  sc_fac[i]:=1;
 end;
 if System_DecSep=',' then exc:='.' else exc:=',';
 if FileExists(ProgramDir+DirSep+'polluxterm.cfg') then begin
  AssignFile (f,ProgramDir+DirSep+'polluxterm.cfg'); reset (f);
    readln (f,s); //Comport
    if s<> '' then actdev:=s else actdev:='COM1';
    readln (f,s); //Baudrate
    if s<>'' then actbaud:=s else actbaud:='19200';
    readln (f,s); //TCP/IP-Address
    if s<> '' then tcpip_adr:=s else tcpip_adr:='192.168.178.50';
    readln (f,s); //TCP/IP-Port
    if s<> '' then tcpip_port:=s else tcpip_adr:='400';
    readln (f,s); //Use Comport
    if s<>'' then tcpip_select:=StrToBool(s) else tcpip_select:=false;
    readln (f,s); //fle_target.Increment
    s:=StringReplace(s,',','.',[rfReplaceAll]);
    val (s,newinc,err);
    if err=0 then  fle_target.Increment:=newinc else fle_target.Increment:=0.25;
    readln (f,s); //fle_target.DecimalPlaces;
    val (s,decplc,err);
    if err=0 then  fle_target.DecimalPlaces:=decplc else fle_target.DecimalPlaces:=3;
    readln (f,s); // show hints
    if s<>'' then mi_showhints.Checked:=StrToBool(s) else mi_showhints.Checked:=true;
    readln (f,s);
    if s<>'' then Lin_Unit:=s else Lin_Unit:='mm';
    readln (f,s);
    if s<>'' then Rot_Unit:=s else Rot_Unit:='°';
    for i:= 1 to 16 do begin
     readln (f,actunit[i]); //unit
     if actunit[i]='' then actunit[i]:='mm';
    end;
    lb_unit.Caption:=actunit[1];
    readln (f,s); // Directmode
    if s<>'' then cbx_direct.Checked:=StrToBool(s) else cbx_direct.Checked:=false;
    for i:= 1 to 16 do begin
     readln (f,s); //scalefactors
     if pos (exc,s) > 0 then s[pos(exc,s)]:=System_DecSep;
     dbl:=1;
     ok:=TryStrToFloat(s,dbl);
     if ok then sc_fac[i]:=dbl else sc_fac[i]:=1;
    end;
    readln (f,s); // Warning different controllers/firmware
    if s<>'' then warn_diff_ctrl:=StrToBool(s) else warn_diff_ctrl:=true;
    readln (f,s); // Support for bad USB-Adapters
    if s<>'' then failport:=StrToBool(s) else failport:=false;
    readln (f,s); //Last Controller node
    val (s,c_last,err);
    if err=0 then Cfg_last_Ctrl:=c_last else Cfg_last_Ctrl:=16;
    readln (f,s); // Show Alive
    if s<>'' then mi_alive.Checked:=StrToBool(s) else mi_alive.Checked:=false;
    closefile (f);
  end;
 for i:= 1 to 16 do begin
   display_pos[i]:='0000000000';
   tg:= int (log10(1000*sc_fac[i]))+2;
   insert ('.',display_pos[i],round(tg));
 end;
 cmdlst:=TStringList.Create;
 show_hints;
 mi_update.Enabled:=true;
 fle_target.MinValue:=-1000;
 fle_target.MaxValue:=1000;
 fle_target.Value:=1;
 fle_target.Increment:=0.25;
 button_status;
end;

procedure Tf_main.FormClose(Sender: TObject);
var runner,tmp: obj_parm;
begin
 Timer1.Enabled:=false;
 if smc_connect then smc_cmd_v2(#3,'',0,0);
 cmdlst.Free;
 CtrlLst.Free;
 if comp_open then smc_close;
 if dbg_rdy then dbg_file_close;
 if first_obj = false then begin
  runner:= first;
  while runner<> NIL do begin
   tmp:= runner^.next; Dispose(runner); runner:= tmp;
  end;
  first_obj:= true;
 end;
end;

procedure Tf_main.btn_nr_negClick(Sender: TObject);
begin
 exec_cmd(FormatFloat('0.000000',-1*fle_target.Value/sc_fac[spe_axis.Value])+' '+spe_axis.Caption+' nr',0);
end;

procedure Tf_main.btn_exeClick(Sender: TObject);
begin
 exec_cmd (ed_command.text,1);
end;

procedure Tf_main.btn_gohomeClick(Sender: TObject);
begin
 exec_cmd('0 '+spe_axis.Caption+' nm',0);
end;

procedure Tf_main.btn_def_homeClick(Sender: TObject);
begin
 exec_cmd('0 '+spe_axis.Caption+' setnpos',0);
end;

procedure Tf_main.btn_cfClick(Sender: TObject);
begin
 if ctrl_ident<>'hydra' then exec_cmd('1 '+spe_axis.Caption+' setaxis',0) else exec_cmd(spe_axis.Caption+' init',0);
 btn_cf.Color:=clLime;
 lb_clerr.Color:= clLime;
 lb_clerr.Caption:='No Error';
end;

procedure Tf_main.MenuItem1Click(Sender: TObject);
begin
  lb_unit.Caption:=Lin_Unit;
  actunit[spe_axis.Value]:=Lin_Unit;
end;

procedure Tf_main.MenuItem2Click(Sender: TObject);
begin
  lb_unit.Caption:=Rot_Unit;
  actunit[spe_axis.Value]:=rot_Unit;
end;

procedure Tf_main.lbx_histDblClick(Sender: TObject);
var idx:Integer;
begin
  idx:=lbx_hist.ItemIndex;
  if (idx>=0) and (idx<lbx_hist.Items.Count) then begin
   ed_command.Text:= trim (lbx_hist.Items[idx]);
  end;
end;

procedure Tf_main.mi_aliveClick(Sender: TObject);
begin
 mi_alive.Checked:= not mi_alive.Checked;
end;

procedure Tf_main.mi_settingsClick(Sender: TObject);
begin
 mi_ws_cs.Caption:='Current Size = '+IntToStr(f_main.Width)+'x'+IntToStr(f_main.Height);
end;

procedure Tf_main.mi_upgradeClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 showhist ('Ctrl+c');
 if spdwin_open then f_speedmode.Close;
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 f_speedup.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_cldiagClick(Sender: TObject);
var oldtmr:Boolean;
begin
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_cldiag.showmodal;
 Timer1.Enabled:=oldtmr;
end;


procedure Tf_main.mi_usrvarClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 showhist ('Ctrl+c');
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_uservar.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_cloopClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 if spdwin_open then f_speedmode.Close;
 showhist ('Ctrl+c');
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 f_cfgcl.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_dlcloneClick(Sender: TObject);
var oldtmr:Boolean;
    s:string;
begin
 mi_dlclone.Enabled:=false;
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 if (diff_ctrl=true) and (pos('pollux',ctrl_ident)>0) then begin
  exec_cmd(spe_axis.Caption+' nidentify',0);
  s:=LowerCase(copy (smc_ans,1,pos(' ',smc_ans)));
  if s='pollux ' then OpenDialog1.InitialDir:=ProgramDir+DirSep+'clonecfg'+DirSep+'pollux';
  if s='pollux2 ' then OpenDialog1.InitialDir:=ProgramDir+DirSep+'clonecfg'+DirSep+'pollux-nt';
 end
 else OpenDialog1.InitialDir:=ProgramDir+DirSep+'clonecfg'+DirSep+ctrl_ident;
 if pos ('.ccf',OpenDialog1.FileName)=0 then OpenDialog1.FileName:='';
 OpenDialog1.Filter:='Clone-Files (*.ccf)|*.ccf|';
 OpenDialog1.DefaultExt:='.ccf';
 if OpenDialog1.Execute and(OpenDialog1.FileName<>OpenDialog1.InitialDir)and(FileExists(OpenDialog1.FileName))then begin
  Timer1.Enabled:=false;
  f_dlclone.lx_cmds.Items.LoadFromFile(OpenDialog1.FileName);
  f_dlclone.ShowModal;
  showscalefactor;
 end;
 Timer1.Enabled:=oldtmr;
 mi_dlclone.Enabled:=true;
end;

procedure Tf_main.cbx_debugChange(Sender: TObject);
begin
 mi_debug.Enabled:=not cbx_debug.Checked;
 dbg_wrt:=cbx_debug.Checked;
 if (tmr_strt) and (dbg_wrt) then begin
  tmr_strt:=false;
  dbg_writeto_file(et.WallClockTime,'Start');
  et.Clear(et_sw); et.Start (et_sw);
 end;
end;

procedure Tf_main.chg_axisItemClick(Sender: TObject);
var i:Integer;
begin
 axes_rbbt:=0;
 for i:= 0 to 15 do begin
  if chg_axis.Checked[i] then axes_rbbt:=axes_rbbt+round (intpower(2,i));
 end;
 btn_rbbt.Enabled:= axes_rbbt<>0;
end;

procedure Tf_main.ed_commandKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
var old_cmdidx:Integer;
begin
 old_cmdidx:=cmd_idx;
 if key=VK_UP then begin
  if cmd_idx>0 then dec (cmd_idx);
 end;
 if key=VK_DOWN then begin
  if cmd_idx<lbx_hist.Items.Count-1 then inc (cmd_idx) else old_cmdidx:=-1;
 end;
 if old_cmdidx<>cmd_idx then begin
  if (cmd_idx>=0) and (cmd_idx<lbx_hist.Items.Count) then ed_command.Text:=Trim (lbx_hist.Items[cmd_idx]);
 end;
 old_cmdidx:=cmd_idx;
end;

procedure Tf_main.ed_commandKeyPress(Sender: TObject; var Key: char);
begin
 if key=#13 then exec_cmd (ed_command.text,1);
end;

procedure Tf_main.ed_rbbtcmdKeyPress(Sender: TObject; var Key: char);
begin
 if (key=#13) and (axes_rbbt<>0) then f_main.btn_rbbtClick(Nil);
end;

procedure Tf_main.ed_spd_stpsChange(Sender: TObject);
var i,err:integer;
begin
 val (ed_spd_stps.Text,i,err);
 if err=0 then spdstps[CAxis]:=i;
end;

procedure Tf_main.input_new (new_obj:obj_parm);
var p: obj_parm;
begin
  if first_obj = true then begin
    first:= new_obj; first^.next:= NIL; last:= first;
  end
  else begin
    p:= last; new_obj^.next:= NIL; p^.next:= new_obj; last:= new_obj;
  end;
  first_obj:= false;
end;

procedure Tf_main.ScaleIt;
var st,sh,sl,sw,i:integer;
    scalex,scaley:double;
    rnr:obj_parm;
begin
 scalex:= f_main.Width/frm_old.X;
 scaley:= f_main.Height/frm_old.y;
 If (o_scalex<>scalex) or (o_scaley<>scaley) then begin
  rnr:=first;
  if (ComponentCount>0) and (first_obj=false) then begin
   for i:= 0 to ComponentCount-1 do begin
    if (Components[i] is TControl) then begin
     sl:=round (rnr^.l*scalex);
     sw:=round (rnr^.w*scalex);
     st:=round (rnr^.t*scaley);
     sh:=round (rnr^.h*scaley);
     TControl(Components[i]).SetBounds(sl,st,sw,sh);
     rnr:=rnr^.next;
    end;
   end;
  end;
  o_scalex:=scalex;
  o_scaley:=scaley;
 end;
end;

procedure Tf_main.FormCreate(Sender: TObject);
var i:integer;
    nw_obj:obj_parm;
begin
 o_scalex:=1;
 o_scaley:=1;
 first_obj:=true;
 frm_old.X:=f_main.Width;
 frm_old.y:=f_main.Height;
 for i:= 0 to ComponentCount-1 do begin
  if (Components[i] is TControl) then begin
   new (nw_obj);
   // nw_obj^.n:=TControl(Components[i]).Name;
   nw_obj^.l:=TControl(Components[i]).BaseBounds.Left;
   nw_obj^.w:=TControl(Components[i]).BaseBounds.Right-TControl(Components[i]).BaseBounds.Left;
   nw_obj^.t:=TControl(Components[i]).BaseBounds.Top;
   nw_obj^.h:=TControl(Components[i]).BaseBounds.Bottom-TControl(Components[i]).BaseBounds.Top;
   input_new (nw_obj);
  end;
 end;
 et:=TEpikTimer.create(nil);
 et.TimebaseSource:=HardwareTimebase;
 //et.TimebaseSource:=SystemTimebase;
 ET.CalibrateCallOverheads(ET.SelectedTimebase^);
 ET.CalibrateTickFrequency(ET.SelectedTimebase^);
 et.Clear(et_sw);
 et.Start(et_sw);
 et.WantDays:=false;
 et.WantMilliseconds:=true;
end;

procedure Tf_main.FormDestroy(Sender: TObject);
begin
 et.Free;
end;

procedure Tf_main.FormResize(Sender: TObject);
begin
  ScaleIt;
end;

procedure Tf_main.btn_rbbtClick(Sender: TObject);
var i,erg:Integer;
    s,prm,cmd:string;
begin
 if (ed_rbbtcmd.Text <>'') and (axes_rbbt<>0) then begin
  erg:=0;  s:='';  prm:=''; cmd:='';
  for i:= 0 to 15 do begin
   if chg_axis.Checked[i] then erg:= erg+round (intpower (2,i));
  end;
  s:= trim (lowercase(ed_rbbtcmd.text));
  i:=1;
  while (i<length(s)) and not (s[i] in ['a'..'z'])do inc (i);
  cmd:= s;
  delete (cmd,1,i-1); cmd:=trim(cmd);
  prm:= trim(copy (s,1,i-1));
  if (cmd_check(cmd)) and (smc_return=0) and (pos ('setncode',ed_rbbtcmd.Text)=0) and (cmd<>'setaxisno') then begin
   exec_cmd(prm+' '+IntToStr(erg*(-1))+' '+cmd,2);
  end
  else if (smc_cmd<>'') and(smc_return=1) then begin
   for i:= 1 to Last_Ctrl do begin
    if (smc_avail[i]) and (chg_axis.Checked[i-1]) then exec_cmd(prm+' '+IntToStr(i)+' '+cmd,2);
   end;
  end;
 end;
end;

procedure Tf_main.btn_selClick(Sender: TObject);
var i:Integer;
begin
 axes_rbbt:=0;
 for i:= 0 to 15 do begin
  chg_axis.Checked[i]:=smc_avail[i+1];
  if chg_axis.Checked[i] then axes_rbbt:=axes_rbbt+round (intpower(2,i));
 end;
 btn_rbbt.Enabled:= axes_rbbt<>0;
end;

procedure Tf_main.btn_invClick(Sender: TObject);
var i:integer;
begin
 for i:= 0 to 15 do if smc_avail[i+1] then chg_axis.Checked[i]:=not chg_axis.Checked[i];
 axes_rbbt:=0;
 for i:= 0 to 15 do begin
  if chg_axis.Checked[i] then axes_rbbt:=axes_rbbt+round (intpower(2,i));
 end;
 btn_rbbt.Enabled:= axes_rbbt<>0;
end;

procedure Tf_main.btn_deselClick(Sender: TObject);
var i:Integer;
begin
 axes_rbbt:=0;
 for i:= 0 to 15 do chg_axis.Checked[i]:=false;
 btn_rbbt.Enabled:=false;
end;

procedure Tf_main.btn_speedmodeClick(Sender: TObject);
var stps,err,x,y:integer;
begin
  val (trim (ed_spd_stps.Text),stps,err);
  if err =0 then begin
   spdwin_open:=true;
   spdstps[CAxis]:=stps;
   f_speedmode.Show;
   x:=f_main.Left+f_main.Width;
   y:=f_main.top+f_main.Height-f_speedmode.Height;
   if Screen.Width>x+f_speedmode.
   Width then f_speedmode.Left:=x;
   if Screen.Height>y+f_speedmode.Height then f_speedmode.top:=y;
  end
  else ed_spd_stps.Text:='10';
end;

procedure Tf_main.mi_crcloneClick(Sender: TObject);
var oldtmr:Boolean;
begin
 mi_crclone.Enabled:=false;
 sleep(50);
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_mkclone.ShowModal;
 Timer1.Enabled:=oldtmr;
 mi_crclone.Enabled:=true;
end;

procedure Tf_main.mi_debugClick(Sender: TObject);
var oldtmr:Boolean;
begin
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 f_dbgbtn.ShowModal;
 if (f_dbgbtn.ModalResult=mrOK) then begin
  if dbg_rdy=false then begin
   dbg_file_open;
   cbx_debug.Visible:=true;
   cbx_debug.Enabled:=dbg_rdy;
  end;
 end
 else begin
  dbg_file_close;
  cbx_debug.Visible:=false;
 end;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_dynpClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 if spdwin_open then f_speedmode.Close;
 showhist ('Ctrl+c');
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 f_cfg_dynamic_parm.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_powerupClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 showhist ('Ctrl+c');
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_powerup.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_stageClick(Sender: TObject);
var oldtmr:Boolean;
begin
 smc_cmd_v2(#3,'',0,0);
 if spdwin_open then f_speedmode.Close;
 showhist ('Ctrl+c');
 oldtmr:= Timer1.Enabled;
 Timer1.Enabled:=false;
 f_stages.showmodal;
 Timer1.Enabled:=oldtmr;
end;

procedure Tf_main.mi_systemunitsClick(Sender: TObject);
var oldlin:boolean;
begin
  oldlin:=(actunit[spe_axis.Value]=Lin_Unit);
  f_system.ed_linear.Text:=Lin_Unit;
  f_system.ed_rot.Text:=Rot_Unit;
  f_system.ShowModal;
  if f_system.ModalResult=mrOK then begin
   Lin_Unit:=f_system.ed_linear.Text;
   Rot_Unit:=f_system.ed_rot.Text;
   if oldlin then actunit[spe_axis.Value]:=Lin_Unit else actunit[spe_axis.Value]:=Rot_Unit;
  end;
end;

procedure Tf_main.btn_rescanClick(Sender: TObject);
var i:integer;
begin
 btn_rescan.Enabled:=false;
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 axes_rbbt:=0;
 serial_str:='';
 btn_rbbt.Enabled:=false;
 Last_Ctrl:=Cfg_last_Ctrl;
 for i:= 1 to 16 do acl_ctrl[i]:=false;
 f_main.Caption:='PolluxTerm';
 for i:= 0 to 15 do chg_axis.Checked[i]:=false;
 if smc_count>0 then cmdlst.Clear;
 f_consts.Show;
 scan_controllers;
 f_consts.Close;
 if (ctrl_ident='unknown') and (smc_count>0) then unknown_ctrl;
 if (diff_ctrl=true) and (warn_diff_ctrl)and (smc_count>0)then MessageDlg ('Warning:','You are using different controllers/firmware!',mtWarning,[mbOK],0);
 if (ctrl_ident='unknown') and (smc_count=0) then begin
  f_main.Caption:='PolluxTerm: NONE@'+actdev;
  button_status;
 end;
 if ctrl_ident<>'unknown' then begin
   lb_clerr.Color:= clLime; lb_clerr.Caption:='No Error';
   button_status;
   If smc_connect then begin
    for i:= 1 to Last_Ctrl do if smc_avail[i] then spe_axis.MaxValue:=i;
   end;
   lb_available.Visible:=true;
   lb_available.caption:='There are '+Inttostr (smc_count)+' SMC-Controllers available!';
   if ctrl_ident='hydra' then begin
    btn_nsave.Caption:='save';
    btn_reset.Caption:='reset';
   end;
   for i:= 1 to Last_Ctrl do if smc_avail[i] then HighAxisNo:=i;
   for i:= Last_Ctrl downto 1 do if smc_avail[i] then LowAxisNo:=i;
   if smc_count>0 then begin
    if tcpip_select then  f_main.Caption:='PolluxTerm: ' +Uppercase(ctrl_ident)+'@'+tcpip_adr+':'+tcpip_port
    else f_main.Caption:='PolluxTerm: ' +Uppercase(ctrl_ident)+'@'+actdev;
    spe_axis.MaxValue:=HighAxisNo;
    spe_axis.MinValue:=LowAxisNo;
    spe_axis.Value:=LowAxisNo;
    CAxis:=LowAxisNo;
    cmdlst.LoadFromFile(ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'vc2-cmds.txt');
    ctrl_cl;
   end;
   if smc_count>1 then begin
    chg_axis.Enabled:=true;
    ed_rbbtcmd.Enabled:=true;
    for i:= 0 to 15 do chg_axis.CheckEnabled[i]:=smc_avail[i+1];
   end
   else begin
    btn_rbbt.Enabled:=false;
    chg_axis.Enabled:=false;
    ed_rbbtcmd.Enabled:=false;
   end;
   button_status;
   lb_scalefac.Visible:=true;
   showscalefactor;
   if (ctrl_ident='taurus') or (ctrl_ident='pegasus') then read_serialno;
   Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
 end;
  btn_rescan.Enabled:=true;
end;

procedure Tf_main.lb_clerrDblClick(Sender: TObject);
begin
 lb_clerr.Color:= clLime;
 lb_clerr.Caption:='No Error';
end;

procedure Tf_main.mi_vc2helpClick(Sender: TObject);
begin
  f_vc2help.Show;
end;

procedure Tf_main.mi_usrtableauClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
  if spdwin_open then f_speedmode.Close;
  f_usrbtn.spe_axis.Value:=spe_axis.Value;
  f_usrbtn.lb_unit.Caption:=actunit[spe_axis.Value];
  f_usrbtn.showmodal;
  Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_scalefactorClick(Sender: TObject);
begin
  f_scale.Spe_Axis.Value:=spe_axis.Value;
  f_scale.showmodal;
  showscalefactor;
end;

procedure Tf_main.btn_nr_posClick(Sender: TObject);
begin
 exec_cmd(FormatFloat('0.000000',fle_target.Value/sc_fac[spe_axis.Value])+' '+spe_axis.Caption+' nr',0);
end;

procedure Tf_main.btn_nmClick(Sender: TObject);
begin
 exec_cmd(FormatFloat('0.000000',fle_target.Value/sc_fac[spe_axis.Value])+' '+spe_axis.Caption+' nm',0);
end;

procedure Tf_main.btn_resetClick(Sender: TObject);
begin
 if ctrl_ident<>'hydra' then exec_cmd(spe_axis.Caption+' nreset',0) else exec_cmd('reset',0);
end;

procedure Tf_main.btn_nsaveClick(Sender: TObject);
begin
 if ctrl_ident<>'hydra' then exec_cmd(spe_axis.Caption+' nsave',0) else exec_cmd('save',0);
end;

procedure Tf_main.btn_ncalClick(Sender: TObject);
begin
 exec_cmd(spe_axis.Caption+' ncal',0);
end;

procedure Tf_main.btn_nrmClick(Sender: TObject);
begin
 exec_cmd(spe_axis.Caption+' nrm',0);
end;

procedure Tf_main.btn_stopallClick(Sender: TObject);
begin
 smc_cmd_v2(#3,'',0,0);
 showhist ('Ctrl+c');
end;

procedure Tf_main.mi_showhintsClick(Sender: TObject);
begin
  mi_showhints.Checked:= not mi_showhints.Checked;
  show_hints;
end;

procedure Tf_main.mi_aboutClick(Sender: TObject);
begin
  f_about.ShowModal;
end;

procedure Tf_main.mi_portClick(Sender: TObject);
begin
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_Comport.ShowModal;
 button_status;
 Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_optionsClick(Sender: TObject);
begin
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_opt.ShowModal;
 Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_savecfgClick(Sender: TObject);
var f:textfile;
    i:integer;
    s:string;
begin
 assignfile (f,ProgramDir+DirSep+'polluxterm.cfg'); rewrite(f);
 writeln (f,actdev); //Comport
 writeln (f,actbaud); //Baudrate
 writeln (f,tcpip_adr); //TCP/IP-Address
 writeln (f,tcpip_port); //TCP/IP-Port
 writeln (f,Bool_To_Str(tcpip_select)); //Use Comport
 s:=FormatFloat('0.000000',fle_target.Increment);
 s:=StringReplace(s,',','.',[rfReplaceAll]);
 writeln (f,s); //Target Increment;
 writeln (f,IntToStr(fle_target.DecimalPlaces));
 writeln (f,Bool_To_Str(mi_showhints.Checked)); //show hints
 WriteLn (f,Lin_Unit);
 WriteLn (f,Rot_Unit);
 for i:= 1 to 16 do writeln (f,actunit[i]); //Unit
 writeln (f,Bool_To_Str(cbx_direct.Checked)); //Directmode
 for i:= 1 to 16 do begin
  s:=FormatFloat('0.0000000000',sc_fac[i]);
  s:=StringReplace(s,',','.',[rfReplaceAll]);
  writeln (f,s); //Scalefactors
 end;
 writeln (f,Bool_To_Str(warn_diff_ctrl));  //different controllers/firmware
 writeln (f,Bool_To_Str(failport)); //Support for bad USB-Adapters
 writeln (f,IntToStr(Cfg_Last_Ctrl));
 writeln (f,Bool_To_Str(mi_alive.Checked));  // Show Alive
 closefile (f);
end;

procedure Tf_main.mi_stopClick(Sender: TObject);
 var s:string;
begin
 s:=smc_cmd_v2(#3,'',0,0);
 if s=''then showhist('Ctrl+c');
end;

procedure Tf_main.mi_editincClick(Sender: TObject);
begin
  f_chginc.ShowModal;
  if f_chginc.ModalResult=mrOK then begin
   fle_target.Increment:=newinc;
   fle_target.DecimalPlaces:=decplc;
  end;
end;

procedure Tf_main.mi_updateClick(Sender: TObject);
begin
 f_update.ShowModal;
end;

procedure Tf_main.mi_downloadClick(Sender: TObject);
var cfgfile:textfile;
    s:String;
    res:Integer;
begin
  Timer1.Enabled:=false; res:=mrOK;
  if ctrl_ident= 'hydra' then res:=MessageDlg ('Warning:','This feature is in teststatus!'+#13+'It will take some time!',mtWarning,[mbOK,mbCancel],0);
  if res=mrOK then begin
   if pos ('.txt',OpenDialog1.FileName)=0 then OpenDialog1.FileName:='';
   OpenDialog1.InitialDir:= ProgramDir+DirSep+'export'+DirSep+ctrl_ident;
   OpenDialog1.Filter:='Text-Files (*.txt)|*.txt';
   OpenDialog1.DefaultExt:='.txt';
   if (OpenDialog1.Execute=True) and (OpenDialog1.FileName<>OpenDialog1.InitialDir) and (FileExists(OpenDialog1.FileName)) then begin
    f_main.Cursor:= crHourGlass;
    if ctrl_ident<>'hydra' then delete_error ('gne',CAxis) else  delete_error('ge',0);
    if ctrl_ident<>'hydra' then smc_cmd_v2('','nclear',CAxis,0) else  smc_cmd_v2('clear','',0,0); sleep (10);
    Sleep(100);
    Application.ProcessMessages;
    Sleep(100);
    Assignfile(cfgfile,OpenDialog1.FileName); reset (cfgfile);
    while not eof (cfgfile) do begin
     readln (cfgfile,s);
     s:=trim (s);
     if (s<>'') and (s[1] in ['0'..'9','+','-','.','"'])and (Pos('#',s)=0) then begin
      s:=StringReplace(s,'%',spe_axis.Caption,[rfReplaceAll]);
      smc_cmd_v2(s,'',0,0);
      if dbg_wrt then begin
       sleep (pollingtime);
       if ctrl_ident<>'hydra' then smc_cmd_v2('','gne',CAxis,1) else smc_cmd_v2('ge','',0,1);
       if smc_ans<>'0' then showhist (s);
       sleep (pollingtime);
       if ctrl_ident<>'hydra' then smc_cmd_v2('','ngsp',CAxis,1) else smc_cmd_v2('gsp','',0,1);
      end;
      sleep (pollingtime);
     end;
    end;
    f_main.Cursor:= crDefault;
    closefile (cfgfile);
   end;
  end;
  Timer1.Enabled:=true;
end;

procedure Tf_main.mi_openvc2Click(Sender: TObject);
begin
 Timer1.Enabled:=false;
 if spdwin_open then f_speedmode.Close;
 f_venus.showmodal;
 Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_exportClick(Sender: TObject);
var cmdfile,bckfile:textfile;
    bckp,s,sres,tt:string;
    cfglst:TStringList;
begin
  Timer1.Enabled:=false;
  cfglst:=TStringList.Create;
  f_main.Cursor:=crHourGlass;
  AssignFile(cmdfile,ProgramDir+DirSep+'controller'+DirSep+ctrl_dir+DirSep+'export.txt');
  reset (cmdfile);
  while not eof (cmdfile) do begin
   readln (cmdfile,s);
   sres:=outstr (s);
   cfglst.Add(sres);
  end;
 CloseFile(cmdfile);
 if ctrl_ident='hydra' then actserialno:=StringReplace(actserialno,'"','',[rfReplaceAll]);
 if (ctrl_ident='taurus') or (ctrl_ident='pegasus') then actserialno:=serial_str+'_Axis'+IntToStr(CAxis);
 while Length (actserialno)<8 do actserialno:='0'+actserialno;
 tt:=ProgramDir+DirSep+'export'+DirSep+ctrl_dir;
 SaveDialog1.InitialDir:=tt;
 SaveDialog1.Filter:='Text-Files (*.txt)|*.txt';
 SaveDialog1.DefaultExt:='.txt';
 SaveDialog1.FileName:=actserialno+'.txt';
 if (SaveDialog1.Execute=true) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
  bckp:=copy (SaveDialog1.FileName,1,pos('.',SaveDialog1.FileName))+'bak';
  if FileExists(bckp)then begin
   AssignFile(bckfile,bckp);
   Erase(bckfile);
  end;
  RenameFile (SaveDialog1.FileName,bckp);
  cfglst.SaveToFile(SaveDialog1.FileName);
 end;
 f_main.Cursor:=crDefault;
 cfglst.Free;
 Timer1.Enabled:= smc_avail[spe_axis.Value] and smc_connect;
end;

procedure Tf_main.mi_calcClick(Sender: TObject);
begin
 f_Calc.Show;
end;

procedure Tf_main.pmi_clearClick(Sender: TObject);
begin
  lbx_hist.Items.Clear;
  cmd_idx:=-1;
end;

procedure Tf_main.PopupMenu3Popup(Sender: TObject);
begin
 mi_ws_cs.Caption:='Current Size = '+IntToStr(f_main.Width)+'x'+IntToStr(f_main.Height);
end;

procedure Tf_main.spe_axisChange(Sender: TObject);
begin
 Timer1.Enabled:=false;
 button_status;
 sleep (50);
 CAxis:=spe_axis.Value;
 showscalefactor;
 ed_spd_stps.Text:=IntToStr(spdstps[CAxis]);
 if spdwin_open then begin
  if spdcur[CAxis]=-1 then spdcur[CAxis]:=1;
  f_speedmode.get_maxvel;
  f_speedmode.show_vel;
 end;
 lb_sd.Visible:=false;
end;

procedure Tf_main.spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_axis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_axis.Value:=nw;
   spe_axisChange(nil);
  end;
 end;
end;

procedure Tf_main.chk_merror;
var ec:integer;
    s,old,t:string;
begin
  s:=smc_cmd_v2('','gme',spe_axis.Value,1);
  ec:=0;
  TryStrToInt(trim (s),ec);
  s:='';
  old:=lb_clerr.Caption;
  if ctrl_ident<>'hydra' then begin
  case ec of
   13: begin
    s:='Axis '+IntToStr(spe_axis.Value)+ ': Following error detected!';
    lb_clerr.Caption:= s;
    lb_clerr.Color:=clred;
   end;
   20: begin
    s:='Axis '+IntToStr(spe_axis.Value)+ ': Amplitude of the 1Vpp-Encoder to low!';
    lb_clerr.Color:=clred;
    lb_clerr.Caption:= s;
   end;
   22: begin
    s:='Axis '+IntToStr(spe_axis.Value)+ ': Encoder Error #22!';
    lb_clerr.Color:=clred;
    lb_clerr.Caption:= s;
   end;
   30: begin
    s:='Axis '+IntToStr(spe_axis.Value)+ ': Parameter stack overflow #30!';
    lb_clerr.Color:=clred;
    lb_clerr.Caption:= s;
   end;
  end;
 end
 else begin
   t:=Trim(smc_cmd_v2(IntToStr(ec)+' merrordecode','',0,1));
   t:=StringReplace(t,'"','',[rfReplaceAll]);
   s:='Axis '+IntToStr(spe_axis.Value)+' '+t;
   lb_clerr.Caption:= s;
   lb_clerr.Color:=clred;
 end;
 if (ec<>0) and (ctrl_ident<>'hydra') then begin
  t:=Trim(smc_cmd_v2('','getaxis',spe_axis.Value,1));
  btn_cf.Enabled:=true;
  if t='0'then btn_cf.color:=clRed else begin
    btn_cf.color:=clLime;
    btn_cf.Enabled:=false;
   end;
 end;
 If (s<> '') and (s<>old) then showhist (s);
 if lb_clerr.Caption<>'No Error' then begin
  btn_cf.Enabled:=true;
 end;
end;

function Tf_main.read_status:boolean;
var s:string;
    err,b,c,d,readerr:integer;
begin
 err:=0;
 s:=Trim (smc_cmd_v2('','nst',spe_axis.Value,1));
 if s<>'' then begin
  val (s,b,readerr);
  if readerr=0 then begin
   c:= b and 1;
   if c=0 then begin
    lb_move.Color:=clLime;
    axis_moves:=false;
    if hwmv=-1 then hwmv:=0;
    if hwmv=1 then inc (hwcnt);
    if hwcnt>0 then hwmv:=0;
   end
   else begin
    lb_move.Color:=clred;
    axis_moves:=true;
    if hwmv=1 then hwmv:=-1;
   end;
   button_status;
   c:= b and 32;
   if c<>0 then lb_clwdw.Color:=clLime else lb_clwdw.Color:=clred;
   c:= b and 4;
   if (c = 4) then chk_merror;
   c:= b and 16;
   spdmode:=c=16;
   if ctrl_ident='hydra' then spdmode:=axis_moves;
   c:= b and 128;
   d:= b and 192;
   if (c=128) or (d=192) then begin
    lb_sd.Visible:=true;
    if c=128 then lb_sd.Color:=clYellow;
    if d=192 then lb_sd.Color:=clRed;
   end
   else lb_sd.Visible:=false;
  end;
 end;
 if (s='') or (readerr<>0)then begin
  lb_move.Color:=clGray;
  lb_clwdw.Color:=clGray;
  inc (err);
 end;
 read_status:= err=0;
end;

function Tf_main.read_position:boolean;
var s,stp:string;
    err,readerr:integer;
    dmy:double;
begin
 err:=0; readerr:=0; stp:='';
 s:=smc_cmd_v2('','np',spe_axis.Value,1);
 val (trim (s),dmy,readerr);
 stp:=FormatFloat(display_pos[spe_axis.Value],abs(dmy*sc_fac[spe_axis.Value]));
 if dmy<0 then stp:='-'+stp else stp:='+'+stp;
 if (length (s)>7) and (readerr=0) then lb_pos.Caption:=stp else begin
  lb_pos.Caption:='###########';
  inc (err);
 end;
 read_position:= err=0;
end;

function Tf_main.read_limitsw:boolean;
var s:string;
begin
 read_limitsw:=true;
 s:=trim (smc_cmd_v2('','getswst',spe_axis.Value,1));
 if (length(s)=3) and ((s[1]='0') or (s[1]='1')) and ((s[3]='0') or (s[3]='1')) then begin
  if s[1]='0' then lb_E1.Color:=clLime else lb_E1.Color:=clred;
  if s[3]='0' then lb_E2.Color:=clLime else lb_E2.Color:=clred;
  if spdmode and (ctrl_ident='hydra') then f_speedmode.get_lmt;
 end
 else begin
  lb_E1.Color:=clGray;
  lb_E2.Color:=clGray;
  read_limitsw:=false;
 end;
end;

procedure Tf_main.Timer1Timer(Sender: TObject);
var s:string;
    cnt:integer;
    read_ok:boolean;
begin
 if tmr_exec then begin
  if alv=4 then alv:=1 else inc (alv);
  if mi_alive.Checked then lb_alive.Caption:=alive[alv];
  inc (whatread); read_ok:=true;
  case whatread of
   1,3,5,7,9:read_ok:=read_Position;
   2,6,10:read_ok:=read_status;
   4,8:read_ok:=read_Limitsw;
  end;
  if read_ok then Timer1.Interval:= pollingtime else if comp_open then begin
   if tcpip_select=false then serl_port.RaiseExcept:=false else eth_port.RaiseExcept:=false;
   Timer1.Enabled:=false;
   Timer1.Interval:=pollingtime*10;
   cnt:=0; s:='';
   repeat
    inc (cnt);
    if tcpip_select=false then s:=serl_port.Recvstring(50) else s:=eth_port.Recvstring(50);
    Application.ProcessMessages;
   until (s='') or (cnt>25);
   Timer1.Enabled:= true;
   if tcpip_select=false then serl_port.RaiseExcept:=true else eth_port.RaiseExcept:=true;
  end;
  if whatread=10 then whatread:=0;
  if showhwmd then f_handwheel.showIt;
 end;
end;

procedure Tf_main.ctrl_cl;
var s:string;
    b,err:integer;
    i:integer;
begin
 if ctrl_ident='pollux-nt' then begin;
  if (cmd_check('getclperiod'))or(cmd_check('getclfactor')) then begin
   for i:= 1 to 16 do begin
    acl_ctrl[i]:=false;
    if smc_avail[i] then begin
     s:=smc_cmd_v2('','getnoptions',i,1);
     val (s,b,err);
     if err=0 then begin
      b:= b and 4;
      acl_ctrl[i]:=(b=4);
     end
     else acl_ctrl[i]:=false;
    end;
   end;
   if acl_ctrl[spe_axis.Value]=true then begin
    lb_clerr.Color:= clLime;
    lb_clerr.Caption:='No Error';
   end;
  end
  else for i:= 1 to 16 do acl_ctrl[i]:=false;
 end;
end;

initialization
  {$I u_main.lrs}

end.

