{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_options;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, u_talktosmc,u_exchange, ExtCtrls;

type

  { Tf_opt }

  Tf_opt = class(TForm)
    btn_close: TBitBtn;
    chg_opt: TCheckGroup;
    lb_sn: TLabel;
    procedure chg_optItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
   opt:integer;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_opt: Tf_opt;

implementation

{ Tf_opt }


procedure Tf_opt.chg_optItemClick(Sender: TObject);
begin
 chg_opt.Checked[0]:=Opt=0;
 chg_opt.Checked[1]:=(opt and 1)=1;
 chg_opt.Checked[2]:=(opt and 2)=2;
 chg_opt.Checked[3]:=(opt and 4)=4;
end;

procedure Tf_opt.FormShow(Sender: TObject);
var s:string;
    err:integer;
begin
   s:=smc_cmd_v2('','getserialno',CAxis,1);
  lb_sn.Caption:='Serial No: '+s;
  s:=smc_cmd_v2('','getnoptions',CAxis,1);
  if s='' then s:=smc_cmd_v2('','getoptions',CAxis,1);
  val (s,opt,err);
  if err=0 then begin
   chg_opt.Checked[0]:=Opt=0;
   chg_opt.Checked[1]:=(opt and 1)=1;
   chg_opt.Checked[2]:=(opt and 2)=2;
   chg_opt.Checked[3]:=(opt and 4)=4;
  end;
end;


initialization
  {$I u_options.lrs}

end.

