{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_pause;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, u_exchange, LMessages;

type

  { Tf_pause }

  Tf_pause = class(TForm)
    btn_ok: TBitBtn;
    btn_cancel: TBitBtn;
    lb_hnt: TLabel;
    procedure btn_okClick(Sender: TObject);
    procedure btn_cancelClick(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_pause: Tf_pause;

implementation

{ Tf_pause }

procedure Tf_pause.btn_okClick(Sender: TObject);
begin
  abreak:=false;
  close;
end;

procedure Tf_pause.btn_cancelClick(Sender: TObject);
begin
  abreak:=true;
  close;
end;

procedure Tf_pause.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
    if Msg.CharCode=27 then btn_cancelClick (nil);
end;

procedure Tf_pause.FormShow(Sender: TObject);
begin
  lb_hnt.Visible:=lb_hnt.Caption<>'';
end;

initialization
  {$I u_pause.lrs}

end.

