{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_port;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls, Spin,u_exchange,u_talktosmc;

type

  { Tf_comport }

  Tf_comport = class(TForm)
    btn_scanports: TBitBtn;
    btn_ok: TBitBtn;
    btn_cancel: TBitBtn;
    cbx_cport: TCheckBox;
    cbx_failport: TCheckBox;
    cmx_dev: TComboBox;
    comx_speed: TComboBox;
    gbx_cp: TGroupBox;
    gbx_net: TGroupBox;
    ed_adr: TLabeledEdit;
    ed_port: TLabeledEdit;
    GroupBox1: TGroupBox;
    lb_dev: TLabel;
    lb_speed: TLabel;
    spe_lctrl: TSpinEdit;
    procedure btn_okClick(Sender: TObject);
    procedure btn_scanportsClick(Sender: TObject);
    procedure cbx_failportChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure spe_lctrlChange(Sender: TObject);
  private
    procedure ScanForPorts;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_comport: Tf_comport;

implementation

{ Tf_comport }
procedure Tf_comport.ScanForPorts;
var s:string;
begin
  s:=Get_Serial_PortNames;
  cmx_dev.Items.Clear;
  if s='' then cmx_dev.Items.Add('<<<NONE>>>') else cmx_dev.Items.CommaText:=s;
  cmx_dev.ItemIndex:=0;
end;


procedure Tf_comport.FormShow(Sender: TObject);
begin
  spe_lctrl.Value:=Cfg_last_Ctrl;
  cbx_failport.Checked:=failport;
  {$IFDEF LINUX}
    cmx_dev.Items.LoadFromFile('ports-linux.cfg');
  {$ENDIF}
  {$IFDEF WINDOWS}
    cmx_dev.Items.LoadFromFile('ports-win.cfg');
  {$ENDIF}
  ed_adr.Text:=tcpip_adr;
  ed_port.Text:=tcpip_port;
  cbx_cport.Checked:=not tcpip_select;
  if (cmx_dev.Items.IndexOf(actdev)<0) and (actdev<>'NONE') and (tcpip_select=false) then cmx_dev.Items.Add(actdev);
  cmx_dev.ItemIndex:=cmx_dev.Items.IndexOf(actdev);
  comx_speed.ItemIndex:=comx_speed.Items.IndexOf(actbaud);
end;

procedure Tf_comport.spe_lctrlChange(Sender: TObject);
begin
 Last_Ctrl:=spe_lctrl.Value;
 Cfg_Last_Ctrl:=spe_lctrl.Value;
end;

procedure Tf_comport.btn_okClick(Sender: TObject);
begin
 actdev:=cmx_dev.Items[cmx_dev.ItemIndex];
 actbaud:=comx_speed.Items[comx_speed.ItemIndex];
 tcpip_adr:=ed_adr.Text;
 tcpip_port:=ed_port.Text;
 tcpip_select:=not cbx_cport.Checked;
end;

procedure Tf_comport.btn_scanportsClick(Sender: TObject);
begin
 ScanForPorts;
end;

procedure Tf_comport.cbx_failportChange(Sender: TObject);
begin
 failport:=cbx_failport.Checked;
end;

initialization
  {$I u_port.lrs}

end.

