{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_talktosmc;

{$mode objfpc}{$H+}

interface
uses
  Classes, SysUtils,synaser,forms,u_dbg,u_exchange,blcksock,u_showcon,EpikTimer;
function smc_open:boolean;
function smc_close:boolean;
function smc_cmd_v2 (cmd1,cmd2:string;ax,ans:integer):string;
function scan_controllers:boolean;
function define_ctrl(ident:String):boolean;
function delete_error (cmd:string;axisid:integer):boolean;

var serl_port:TBlockSerial;
    smccon:string;
    smc_connect:boolean;
    smc_cerr:integer;
    smc_avail:array [1..16] of boolean;
    smc_count,open_err:integer;
    comp_open:boolean;
    answ:string;
    smc_ans:string;
    eth_port:TTCPBlockSocket;
    et:TEpikTimer;
    et_sw:TimerData;

implementation

{------------------------------------------------------------------------------}
function define_ctrl(ident:String):boolean;
var i,j,pt,err:Integer;
    s,t:string;
begin
 pollingtime:=125; pt:=125;
 i:=0; j:=-1;
 ident:=lowercase (ident);
 delete (ident,pos(' ',ident),25);
 while (i<CtrlLst.Count) and (j=-1) do begin
  s:=copy (CtrlLst[i],1,Pos(';',CtrlLst[i])-1);
  if failport then begin
   if Pos (s+' ',ident+' ')>0 then j:=i;
  end
  else if s=ident then j:=i;
  inc (i);
 end;
 if j<>-1 then begin
  s:= CtrlLst[j];
  delete (s,1,pos(';',s));
  t:=copy (s,1,Pos(';',s)-1);
  if t<>'' then ctrl_ident:=t;
  delete (s,1,pos(';',s));
  val (s,pt,err);
  if (err=0) and (pt>10) then pollingtime:=pt;
  ctrl_dir:=t;
  define_ctrl:=true;
 end
 else begin
  ctrl_ident:='unknown';
  define_ctrl:=false;
 end;
end;
{------------------------------------------------------------------------------}
function scan_controllers_cport:boolean;
var ax,firstctrl:string;
    i:Integer;
    stp:boolean;
begin
 ctrl_ident:='unknown';  pollingtime:=125;  diff_ctrl:=false; firstctrl:='';
 ax:='1';
 smc_count:=0; stp:=false;
 for i:= 1 to 16 do smc_avail[i]:=false;
 F_consts.pgb_connnect.Max:=Last_Ctrl;
 serl_port.RaiseExcept:=false;
 i:=1; F_consts.con_abbr:=false;
 serl_port.Purge;
 while (i<=Last_Ctrl) and (F_consts.con_abbr=false) and (stp=false) do begin
  F_consts.pgb_connnect.Position:=i;
  Application.ProcessMessages;
  ax:=IntToStr(i);
  serl_port.Purge;
  if failport then Sleep(125);
  serl_port.Purge;
  if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),ax+' nidentify');
  serl_port.SendString (ax+' nidentify'+#13#10);
  smccon:=serl_port.recvstring(smc_timeout);
  if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),'  >'+smccon+'<');
  smc_cerr:= serl_port.LastError;
  if smc_cerr=0 then begin
   smc_avail[i]:= true;
   if firstctrl='' then begin
    firstctrl:=smccon;
    define_ctrl (smccon);
    if ctrl_ident='taurus' then Last_Ctrl:=1;
    if ctrl_ident='hydra' then Last_Ctrl:=2;
   end
   else if (firstctrl<>smccon)and (ctrl_ident<>'hydra') then diff_ctrl:=true;
   inc (smc_count);
  end;
  inc (i);
 end;
 if smc_count >0 then scan_controllers_cport:=true else scan_controllers_cport:=false;
 serl_port.RaiseExcept:=true;
 if smc_count>0 then  smc_connect:=true else smc_connect:=false;
end;
{------------------------------------------------------------------------------}
function scan_controllers_tcpip:boolean;
var ax,firstctrl:string;
    i:Integer;
    stp:boolean;
begin
 ctrl_ident:='unknown';  pollingtime:=125;  diff_ctrl:=false; firstctrl:='';
 ax:='1';
 smc_count:=0; stp:=false;
 for i:= 1 to 16 do smc_avail[i]:=false;
 F_consts.pgb_connnect.Max:=Last_Ctrl;
 eth_port.RaiseExcept:=false;
 i:=1; F_consts.con_abbr:=false;
 eth_port.Purge;
 while (i<=Last_Ctrl) and (F_consts.con_abbr=false) and (stp=false) do begin
  F_consts.pgb_connnect.Position:=i;
  Application.ProcessMessages;
  ax:=IntToStr(i);
  eth_port.Purge;
  if failport then Sleep(125);
  eth_port.Purge;
  if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),ax+' nidentify');
  eth_port.SendString (ax+' nidentify'+#13#10);
  smccon:=eth_port.recvstring(smc_timeout);
  if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),'  >'+smccon+'<');
  smc_cerr:= eth_port.LastError;
  if smc_cerr=0 then begin
   smc_avail[i]:= true;
   if firstctrl='' then begin
    firstctrl:=smccon;
    define_ctrl (smccon);
    if ctrl_ident='taurus' then Last_Ctrl:=1;
    if ctrl_ident='hydra' then Last_Ctrl:=2;
   end
   else if (firstctrl<>smccon)and (ctrl_ident<>'hydra') then diff_ctrl:=true;
   inc (smc_count);
  end;
  inc (i);
 end;
 if smc_count >0 then scan_controllers_tcpip:=true else scan_controllers_tcpip:=false;
 eth_port.RaiseExcept:=true;
 if smc_count>0 then smc_connect:=true else smc_connect:=false;
end;
{------------------------------------------------------------------------------}
function scan_controllers:boolean;
begin
 if tcpip_select=false then scan_controllers:=scan_controllers_cport else scan_controllers:= scan_controllers_tcpip;
end;
{------------------------------------------------------------------------------}
function smc_open_cport:boolean;
var ok:boolean;
    ax,firstctrl:string;
    i:integer;
    spd:Integer;
    stp:boolean;
begin
 ctrl_ident:='unknown';  pollingtime:=125; stp:=false;  diff_ctrl:=false; firstctrl:='';
 for i:= 1 to 16 do smc_avail[i]:=false;
 ok:=false; smc_count:=0;  comp_open:=false;
 serl_port:=TBlockserial.Create;
 F_consts.pgb_connnect.Max:=Last_Ctrl;
 try
   serl_port.RaiseExcept:=false;
   serl_port.Connect(actdev);
   spd:=StrToInt(actbaud);
   serl_port.Config(spd,8,'N',SB1,false,false);
   open_err:=serl_port.LastError;
   if open_err=0 then begin
    comp_open:=true;   
    i:=1; F_consts.con_abbr:=false;
    serl_port.Purge;
    while (i<=Last_Ctrl) and (F_consts.con_abbr=false) and (stp=false) do begin
     Application.ProcessMessages;
     F_consts.pgb_connnect.Position:=i;
     ax:=IntToStr(i);
     serl_port.Purge;
     serl_port.SendString (ax+' nidentify'+#13#10);
     if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),ax+' nidentify');
     smccon:=serl_port.recvstring(smc_timeout);
     if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),'  >'+smccon+'<');
     smc_cerr:= serl_port.LastError;
     if smc_cerr=0 then begin
      ok:=true;
      smc_connect:=true;
      smc_avail[i]:= true;
      if firstctrl='' then begin
       firstctrl:=smccon;
       define_ctrl (smccon);
       if ctrl_ident='taurus' then Last_Ctrl:=1;
       if ctrl_ident='hydra' then Last_Ctrl:=2;
      end
      else if (firstctrl<>smccon)and (ctrl_ident<>'hydra') then diff_ctrl:=true;
      inc (smc_count);
     end;
     inc (i);
    end;
   end
   else ok:=false;
  finally
  end;
  smc_open_cport:=ok;
  serl_port.RaiseExcept:=true;
end;
{------------------------------------------------------------------------------}
function smc_open_tcpip:boolean;
var ok:boolean;
    ax,firstctrl:string;
    i:integer;
    stp:boolean;
begin
 ctrl_ident:='unknown';  pollingtime:=125; stp:=false;  diff_ctrl:=false; firstctrl:='';
 for i:= 1 to 16 do smc_avail[i]:=false;
 ok:=false; smc_count:=0;  comp_open:=false;
 F_consts.pgb_connnect.Max:=Last_Ctrl;
 try
  open_err:=0;
  eth_port:=TTCPBlockSocket.create;
  eth_port.setLinger(true,5000);
  eth_port.RaiseExcept:=false;
  eth_port.Connect (tcpip_adr,tcpip_port);
  open_err:=eth_port.LastError;
  if open_err=0 then begin
   comp_open:=true;   
   i:=1; F_consts.con_abbr:=false;
   eth_port.Purge;
   while (i<=Last_Ctrl) and (F_consts.con_abbr=false) and (stp=false) do begin
    Application.ProcessMessages;
    F_consts.pgb_connnect.Position:=i;
    ax:=IntToStr(i);
    eth_port.Purge;
    eth_port.SendString (ax+' nidentify'+#13#10);
    if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),ax+' nidentify');
    smccon:=eth_port.recvstring(smc_timeout);
    if dbg_wrt=true then dbg_writeto_file (ET.Elapsedstr(et_sw),'  >'+smccon+'<');
    smc_cerr:= eth_port.LastError;
    if smc_cerr=0 then begin
     ok:=true;
     smc_connect:=true;
     smc_avail[i]:= true;
     if firstctrl='' then begin
      firstctrl:=smccon;
      define_ctrl (smccon);
      if ctrl_ident='taurus' then Last_Ctrl:=1;
      if ctrl_ident='hydra' then Last_Ctrl:=2;
     end
     else if (firstctrl<>smccon)and (ctrl_ident<>'hydra') then diff_ctrl:=true;
     inc (smc_count);
    end;
    inc (i);
   end;
  end
  else ok:=false;
  finally
  end;
  smc_open_tcpip:=ok;
  eth_port.RaiseExcept:=true;
end;
{------------------------------------------------------------------------------}
function smc_open:boolean;
begin
 f_consts.pgb_connnect.Max:=Last_Ctrl;
 if tcpip_select=false then smc_open:=smc_open_cport else smc_open:=smc_open_tcpip;
end;
{------------------------------------------------------------------------------}
function smc_cmd_cport(cmd1,cmd2:string;ax,ans:integer):string;
var s:string;
    oldraise:boolean;
begin
 if smc_connect then begin
  oldraise:=serl_port.RaiseExcept;
  serl_port.RaiseExcept:=false;
  s:='';
  if (ax=0) and (cmd1=#3) then serl_port.SendString (#3+#13#10);
  if ax<>0 then serl_port.SendString (cmd1+' '+IntTostr (ax)+' '+cmd2+#13#10)
  else serl_port.SendString (cmd1+#13#10);
  if (ax<>0) and (dbg_wrt=true) then dbg_writeto_file (ET.Elapsedstr(et_sw),cmd1+' '+IntTostr (ax)+' '+cmd2)
  else dbg_writeto_file (ET.Elapsedstr(et_sw),cmd1);
  if ans>0 then begin
   s:=serl_port.recvstring(smc_timeout);
   smc_cerr:= serl_port.LastError;
   if smc_cerr=0 then smc_cmd_cport:=s else s:='';
  end;
  if (dbg_wrt=true) and (ans>0) then dbg_writeto_file (ET.Elapsedstr(et_sw),'  >'+s+'<');
  smc_cmd_cport:=s;
  smc_ans:= s;
  serl_port.RaiseExcept:=oldraise;
 end;
end;
{------------------------------------------------------------------------------}
function smc_cmd_tcpip(cmd1,cmd2:string;ax,ans:integer):string;
var s:string;
    oldraise:boolean;
begin
 if smc_connect then begin
  oldraise:=eth_port.RaiseExcept;
  eth_port.RaiseExcept:=false;
  s:='';
  if (ax=0) and (cmd1=#3) then eth_port.SendString (#3+#13#10);
  if ax<>0 then eth_port.SendString (cmd1+' '+IntTostr (ax)+' '+cmd2+#13#10)
  else eth_port.SendString (cmd1+#13#10);
  if (ax<>0) and (dbg_wrt=true) then dbg_writeto_file (ET.Elapsedstr(et_sw),cmd1+' '+IntTostr (ax)+' '+cmd2)
  else dbg_writeto_file (ET.Elapsedstr(et_sw),cmd1);
  if ans>0 then begin
   s:=eth_port.recvstring(smc_timeout);
   smc_cerr:= eth_port.LastError;
   if smc_cerr=0 then smc_cmd_tcpip:=s else s:='';
  end;
  if (dbg_wrt=true) and (ans>0) then dbg_writeto_file(ET.Elapsedstr(et_sw),'  >'+s+'<');
  smc_cmd_tcpip:=s;
  smc_ans:= s;
  eth_port.RaiseExcept:=oldraise;
 end;
end;
{------------------------------------------------------------------------------}
function smc_cmd_v2(cmd1,cmd2:string;ax,ans:integer):string;
begin
  cmd1:=StringReplace(cmd1,',','.',[rfReplaceAll]);
  cmd2:=StringReplace(cmd2,',','.',[rfReplaceAll]);
  if tcpip_select=false then smc_cmd_cport (cmd1,cmd2,ax,ans) else smc_cmd_tcpip (cmd1,cmd2,ax,ans);
  ans_be_str:=pos ('"',smc_ans)>0;
  smc_ans:=StringReplace(smc_ans,'"','',[rfReplaceAll]);
  smc_cmd_v2:=smc_ans;
end;
{------------------------------------------------------------------------------}
function smc_close_cport:boolean;
begin
 serl_port.Free;
 smc_cerr:= serl_port.LastError;
 smc_connect:=false;
 comp_open:=false;
 if smc_cerr=0 then smc_close_cport:=true else smc_close_cport:= false;
end;
{------------------------------------------------------------------------------}
function smc_close_tcpip:boolean;
begin
 eth_port.CloseSocket;
 smc_cerr:= eth_port.LastError;
 smc_connect:=false;
 comp_open:=false;
 if smc_cerr=0 then smc_close_tcpip:=true else smc_close_tcpip:= false;
end;
{------------------------------------------------------------------------------}
function smc_close:boolean;
begin
  if tcpip_select=false then smc_close:=smc_close_cport else smc_close:= smc_close_tcpip;
end;
{------------------------------------------------------------------------------}
function delete_error (cmd:string;axisid:integer):boolean;
var cnt:integer;
   s:string;
begin
  cnt:=0;
  repeat
   if axisid<>0 then s:=trim (smc_cmd_v2('',cmd,axisid,1)) else s:=trim (smc_cmd_v2(cmd,'',axisid,1));
   inc(cnt);
  until (s='0') or (cnt>30);
  delete_error:=s='0';
end;
{------------------------------------------------------------------------------}
var i:integer;
begin
 smc_count:=0;
 comp_open:=false;
 for i:= 1 to Last_Ctrl do smc_avail[i]:=false;
 tmr_strt:=true;
end.

