{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_unknown_ctrl;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls,u_talktosmc,u_exchange;

type

  { Tf_unknown_ctrl }

  Tf_unknown_ctrl = class(TForm)
    btn_cancel: TBitBtn;
    btn_ok: TBitBtn;
    Memo1: TMemo;
    rg_use_ctrl: TRadioGroup;
    procedure btn_cancelClick(Sender: TObject);
    procedure btn_okClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rg_use_ctrlClick(Sender: TObject);

  private
    procedure get_ctrl_lst;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_unknown_ctrl: Tf_unknown_ctrl;

implementation

{ Tf_unknown_ctrl }

procedure Tf_unknown_ctrl.btn_cancelClick(Sender: TObject);
begin
 close;
 ModalResult:=mrCancel;
end;

procedure Tf_unknown_ctrl.btn_okClick(Sender: TObject);
var err:integer;
    s:string;
begin
 s:=CtrlLst[rg_use_ctrl.ItemIndex];
 delete (s,1,pos(';',s));
 ctrl_ident:=copy (s,1,pos(';',s)-1);
 delete (s,1,pos(';',s));
 val (s,pollingtime,err);
 if err<>0 then pollingtime:=125;
 ctrl_dir:=ctrl_ident;
 close;
 ModalResult:=mrOK;
end;

procedure Tf_unknown_ctrl.get_ctrl_lst;
var i,j:integer;
    s:string;
    f:boolean;
begin
 rg_use_ctrl.Items.Clear;
 for i:= 0 to CtrlLst.Count-1 do begin
  s:=CtrlLst[i];
  delete (s,1,pos(';',s)); delete (s,pos(';',s),10);
  f:=false;
  for j:=0 to rg_use_ctrl.Items.Count-1 do begin
   if (rg_use_ctrl.Items[j]=s) and (f=false) then f:=true;
  end;
  if f=false then rg_use_ctrl.Items.Add(s);
 end;
end;

procedure Tf_unknown_ctrl.FormShow(Sender: TObject);
begin
  get_ctrl_lst;
  f_unknown_ctrl.ActiveControl:=btn_cancel;
  if rg_use_ctrl.Items.Count>0 then rg_use_ctrl.ItemIndex:=0;
  rg_use_ctrl.ItemIndex:=-1;
  btn_ok.Enabled:=false;
end;

procedure Tf_unknown_ctrl.rg_use_ctrlClick(Sender: TObject);
begin
 btn_ok.Enabled:=rg_use_ctrl.ItemIndex<>-1;
end;

initialization
  {$I u_unknown_ctrl.lrs}

end.

