{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_upgrade;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,u_talktosmc,u_exchange,
  Buttons, StdCtrls, Spin;

type

  { Tf_speedup }

  Tf_speedup = class(TForm)
    btn_order: TBitBtn;
    btn_close: TBitBtn;
    btn_save: TBitBtn;
    btn_clear: TBitBtn;
    Memo1: TMemo;
    Memo2: TMemo;
    SaveDialog1: TSaveDialog;
    spe_axis: TSpinEdit;
    procedure btn_clearClick(Sender: TObject);
    procedure btn_orderClick(Sender: TObject);
    procedure btn_saveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
  private
    srno,optn,versn:string;
    procedure readvar;
    { private declarations }
  public
    { public declarations }
  end; 

var
  f_speedup: Tf_speedup;

implementation

{ Tf_speedup }

procedure Tf_speedup.readvar;
var opt,err:Integer;
begin
 srno:= trim (smc_cmd_v2('','getserialno',spe_axis.Value,1)); sleep (10);
 optn:= trim (smc_cmd_v2('','getnoptions',spe_axis.Value,1)); sleep (10);
 if optn= '' then begin
  optn:= trim (smc_cmd_v2('','getoptions',spe_axis.Value,1)); sleep (10);
 end;
 versn:= trim (smc_cmd_v2('','nversion',spe_axis.Value,1)); sleep (10);
 val (optn,opt,err);
  if err=0 then begin
   btn_order.Enabled:= smc_avail[spe_axis.Value];
  end;
end;


procedure Tf_speedup.FormShow(Sender: TObject);
begin
 Memo2.Clear;
 spe_axis.MinValue:= LowAxisNo;
 spe_axis.MaxValue:=HighAxisNo;
 spe_axis.Enabled:=smc_count>1;
 spe_axis.Value:=CAxis;
 btn_order.Enabled:=false;
 btn_clear.Enabled:=false;
 btn_save.Enabled:=false;
 if smc_avail[spe_axis.Value] then readvar;
end;

procedure Tf_speedup.spe_axisChange(Sender: TObject);
begin
 btn_order.Enabled:=false;
 if smc_avail[spe_axis.Value] then readvar;
end;

procedure Tf_speedup.btn_orderClick(Sender: TObject);
begin
  Memo2.Lines.Add('SN: '+srno+', Options: '+optn+', Firmware: '+versn);
  btn_save.Enabled:=true;
  btn_clear.Enabled:=true;
end;

procedure Tf_speedup.btn_saveClick(Sender: TObject);
begin
 SaveDialog1.Filter:='Text-Files (*.txt)|*.txt';
 SaveDialog1.DefaultExt:='.txt';
 SaveDialog1.InitialDir:=ProgramDir;
 SaveDialog1.FileName:='order.txt';
 if (SaveDialog1.Execute=true) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
   Memo2.Lines.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure Tf_speedup.btn_clearClick(Sender: TObject);
begin
  Memo2.Clear;
  btn_save.Enabled:=false;
  btn_clear.Enabled:=false;
end;

initialization
  {$I u_upgrade.lrs}

end.

