{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_usrbtn;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, Spin, u_editbutton, u_talktosmc, u_exchange, LMessages;
type
 us_btn= record
    cmd:string;    //smc command
    line1:string;  //button line 1
    line2:string;  //button line 2
    line3:string;  //button line 3
    icon:string;   //filename of icon
    hint:string;   //hint text
    axis:integer;  //show axis number
    visib:boolean; //button visible
  end;
type

  { Tf_usrbtn }
  Tf_usrbtn = class(TForm)
    chb_showhint: TCheckBox;
    lb_pos: TLabel;
    lb_e1: TLabel;
    lb_e2: TLabel;
    lb_move: TLabel;
    lb_unit: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    spe_axis: TSpinEdit;
    Timer1: TTimer;
    usrbtn1: TBitBtn;
    btn_close: TBitBtn;
    btn_stop: TBitBtn;
    btn_save: TBitBtn;
    btn_load: TBitBtn;
    chb_edit: TCheckBox;
    usrbtn7: TBitBtn;
    usrbtn2: TBitBtn;
    usrbtn3: TBitBtn;
    usrbtn5: TBitBtn;
    usrbtn6: TBitBtn;
    usrbtn8: TBitBtn;
    usrbtn4: TBitBtn;
    usrbtn9: TBitBtn;
    procedure btn_stopClick(Sender: TObject);
    procedure btn_saveClick(Sender: TObject);
    procedure btn_loadClick(Sender: TObject);
    procedure chb_editChange(Sender: TObject);
    procedure chb_showhintChange(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure usrbtn1Click(Sender: TObject);
    procedure usrbtn2Click(Sender: TObject);
    procedure usrbtn3Click(Sender: TObject);
    procedure usrbtn4Click(Sender: TObject);
    procedure usrbtn5Click(Sender: TObject);
    procedure usrbtn6Click(Sender: TObject);
    procedure usrbtn7Click(Sender: TObject);
    procedure usrbtn8Click(Sender: TObject);
    procedure usrbtn9Click(Sender: TObject);
  private
   vc2_moveend:boolean;
   whatread:byte;
   procedure ActShowStatus;
   procedure button_status (rdy:boolean);
   procedure edit_btn (btnno: integer);
   function move_end:boolean;
   function read_limitsw: boolean;
   function read_position: boolean;
   procedure set_act(btnno: integer);
   procedure   show_buttons;
    { private declarations }
  public
    usbtn:array [1..9] of us_btn;
    act:us_btn;
    { public declarations }
  end;
var
  f_usrbtn: Tf_usrbtn;

implementation

{ Tf_usrbtn }

procedure Tf_usrbtn.button_status (rdy:boolean);
begin
 if tbl_loaded then begin
  usrbtn1.Enabled:=rdy and (usbtn[1].line1<>'');
  usrbtn2.Enabled:=rdy and (usbtn[2].line1<>'');
  usrbtn3.Enabled:=rdy and (usbtn[3].line1<>'');
  usrbtn4.Enabled:=rdy and (usbtn[4].line1<>'');
  usrbtn5.Enabled:=rdy and (usbtn[5].line1<>'');
  usrbtn6.Enabled:=rdy and (usbtn[6].line1<>'');
  usrbtn7.Enabled:=rdy and (usbtn[7].line1<>'');
  usrbtn8.Enabled:=rdy and (usbtn[8].line1<>'');
  usrbtn9.Enabled:=rdy and (usbtn[9].line1<>'');
 end;
end;


procedure Tf_usrbtn.usrbtn1Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[1].cmd,'',0,0);
   spe_axis.Value:=usbtn[1].axis;
   button_status (false);
  end
  else edit_btn (1);
end;

procedure Tf_usrbtn.usrbtn2Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[2].cmd,'',0,0);
   spe_axis.Value:=usbtn[2].axis;
   button_status (false);
  end
  else edit_btn (2);
end;

procedure Tf_usrbtn.usrbtn3Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
    smc_cmd_v2(usbtn[3].cmd,'',0,0);
    spe_axis.Value:=usbtn[3].axis;
    button_status (false);
  end
  else edit_btn (3);
end;

procedure Tf_usrbtn.usrbtn4Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[4].cmd,'',0,0);
   spe_axis.Value:=usbtn[4].axis;
   button_status (false);
  end
  else edit_btn (4);
end;

procedure Tf_usrbtn.usrbtn5Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
    smc_cmd_v2(usbtn[5].cmd,'',0,0);
    spe_axis.Value:=usbtn[5].axis;
    button_status (false);
  end
  else edit_btn (5);
end;

procedure Tf_usrbtn.usrbtn6Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[6].cmd,'',0,0);
   spe_axis.Value:=usbtn[6].axis;
   button_status (false);
  end
  else edit_btn (6);
end;

procedure Tf_usrbtn.usrbtn7Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[7].cmd,'',0,0);
   spe_axis.Value:=usbtn[7].axis;
   button_status (false);
  end
  else edit_btn (7);
end;

procedure Tf_usrbtn.usrbtn8Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[8].cmd,'',0,0);
   spe_axis.Value:=usbtn[8].axis;
   button_status (false);
  end
  else edit_btn (8);
end;

procedure Tf_usrbtn.usrbtn9Click(Sender: TObject);
begin
  if chb_edit.Checked=false then begin
   smc_cmd_v2(usbtn[9].cmd,'',0,0);
   spe_axis.Value:=usbtn[9].axis;
   button_status (false);
  end
  else edit_btn (9);
end;


procedure Tf_usrbtn.set_act (btnno: integer);
var s:string;
begin
 act:=usbtn[btnno];
 s:='';
 if act.line1<>'' then s:=act.line1;
 {$IFDEF LINUX}
  if act.line2<>'' then s:=s+LineEnding+act.line2;
  if act.line3<>'' then s:=s+LineEnding+act.line3;
 {$ENDIF}
 case btnno of
  1: begin
     usrbtn1.Caption:=s;
     usrbtn1.Visible:=act.visib;
     usrbtn1.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn1.Glyph.LoadFromFile(act.icon) else usrbtn1.Glyph:=nil;
  end;
   2: begin
     usrbtn2.Caption:=s;
     usrbtn2.Visible:=act.visib;
     usrbtn2.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn2.Glyph.LoadFromFile(act.icon) else usrbtn2.Glyph:=nil;
  end;
  3: begin
     usrbtn3.Caption:=s;
     usrbtn3.Visible:=act.visib;
     usrbtn3.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn3.Glyph.LoadFromFile(act.icon) else usrbtn3.Glyph:=nil;
  end;
  4: begin
     usrbtn4.Caption:=s;
     usrbtn4.Visible:=act.visib;
     usrbtn4.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn4.Glyph.LoadFromFile(act.icon) else usrbtn4.Glyph:=nil;
  end;
  5: begin
     usrbtn5.Caption:=s;
     usrbtn5.Visible:=act.visib;
     usrbtn5.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn5.Glyph.LoadFromFile(act.icon) else usrbtn5.Glyph:=nil;
  end;
  6: begin
     usrbtn6.Caption:=s;
     usrbtn6.Visible:=act.visib;
     usrbtn6.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn6.Glyph.LoadFromFile(act.icon) else usrbtn6.Glyph:=nil;
  end;
  7: begin
     usrbtn7.Caption:=s;
     usrbtn7.Visible:=act.visib;
     usrbtn7.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn7.Glyph.LoadFromFile(act.icon) else usrbtn7.Glyph:=nil;
  end;
  8: begin
     usrbtn8.Caption:=s;
     usrbtn8.Visible:=act.visib;
     usrbtn8.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn8.Glyph.LoadFromFile(act.icon) else usrbtn8.Glyph:=nil;
  end;
  9: begin
     usrbtn9.Caption:=s;
     usrbtn9.Visible:=act.visib;
     usrbtn9.Hint:=act.hint;
     if (act.icon<>'') and (FileExists(act.icon)) then usrbtn9.Glyph.LoadFromFile(act.icon) else usrbtn9.Glyph:=nil;
  end;
 end;
end;


procedure Tf_usrbtn.edit_btn(btnno: integer);
begin
  f_editbutton.Caption:='Edit-User-Button '+IntToStr(btnno);
  act:=usbtn[btnno];
  f_editbutton.ed_cmd.Text:=act.cmd;
  f_editbutton.ed_btnline1.Text:=act.line1;
  f_editbutton.ed_btnline2.Text:=act.line2;
  f_editbutton.ed_btnline3.Text:=act.line3;
  f_editbutton.ed_btnhint.text:= act.hint;
  f_editbutton.cb_visible.Checked:=act.visib;
  f_editbutton.fn:=act.icon;
  f_editbutton.spe_showaxis.Value:=act.axis;
  f_editbutton.ShowModal;
  if f_editbutton.ModalResult =mrOK then begin
    act.cmd:=f_editbutton.ed_cmd.Text;
    act.line1:=f_editbutton.ed_btnline1.Text;
    act.line2:=f_editbutton.ed_btnline2.Text;
    act.line3:=f_editbutton.ed_btnline3.Text;
    act.hint:=f_editbutton.ed_btnhint.Text;
    act.visib:=f_editbutton.cb_visible.Checked;
    act.icon:=f_editbutton.fn;
    act.axis:=f_editbutton.spe_showaxis.Value;
    usbtn[btnno]:=act;
    set_act(btnno);
   end;
   btn_save.Enabled:=true;
end;

procedure Tf_usrbtn.btn_stopClick(Sender: TObject);
begin
  smc_cmd_v2(#3,'',0,0);
  button_status(true);
end;

procedure Tf_usrbtn.btn_saveClick(Sender: TObject);
var f,b:textfile;
    i:integer;
    bckup:string;
begin
 SaveDialog1.FileName:='';
 SaveDialog1.InitialDir:=ProgramDir+DirSep+'usertableau';
 SaveDialog1.Filter:='User-Tableau-Files (*.ubt)|*.ubt';
 SaveDialog1.DefaultExt:='.ubt';
 if (SaveDialog1.Execute) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
  if FileExists(SaveDialog1.FileName) then begin
   bckup:=ChangeFileExt(SaveDialog1.FileName,'.bak');
   if FileExists(bckup) then begin
    AssignFile(b,bckup);
    Erase(b);
   end;
   RenameFile(SaveDialog1.FileName,bckup);
  end;
  if pos ('.ubt',SaveDialog1.FileName)= 0 then SaveDialog1.FileName:=SaveDialog1.FileName+'.ubt';
  AssignFile(f,SaveDialog1.FileName); Rewrite(f);
  for i:= 1 to 9 do begin
    writeln (f,'<<< USERBUTTON '+IntToStr(i)+' START >>>');
    writeln (f,'   '+usbtn[i].cmd);
    writeln (f,'   '+usbtn[i].line1);
    writeln (f,'   '+usbtn[i].line2);
    writeln (f,'   '+usbtn[i].line3);
    writeln (f,'   '+usbtn[i].icon);
    writeln (f,'   '+usbtn[i].hint);
    writeln (f,'   '+IntToStr(usbtn[i].axis));
    writeln (f,'   '+Bool_To_Str(usbtn[i].visib));
    writeln (f,'<<< USERBUTTON '+IntToStr(i)+' END >>>');
    writeln (f,'');
  end;
  CloseFile(f);
 end;
end;

procedure Tf_usrbtn.btn_loadClick(Sender: TObject);
var f:textfile;
    i,err:Integer;
    s:string;
begin
 OpenDialog1.InitialDir:=ProgramDir+DirSep+'usertableau';
 OpenDialog1.Filter:='User-Tableau-Files (*.ubt)|*.ubt';
 OpenDialog1.DefaultExt:='.ubt';
 if (OpenDialog1.Execute) and (OpenDialog1.FileName<>OpenDialog1.InitialDir)and(FileExists(OpenDialog1.FileName)) then begin
   AssignFile(f,OpenDialog1.FileName); Reset (f);
    for i:= 1 to 9 do begin
      ReadLn (f,s);   //dummy
      ReadLn (f,s); delete (s,1,3); usbtn[i].cmd:=s;
      ReadLn (f,s); delete (s,1,3); usbtn[i].line1:=s;
      ReadLn (f,s); delete (s,1,3); usbtn[i].line2:=s;
      ReadLn (f,s); delete (s,1,3); usbtn[i].line3:=s;
      ReadLn (f,s); delete (s,1,3);
      {$IFDEF LINUX}
        s:=StringReplace(s,'\','/',[ rfReplaceAll]);
      {$ENDIF}
      {$IFDEF WINDOWS}
        s:=StringReplace(s,'/','\',[ rfReplaceAll]);
      {$ENDIF}
      usbtn[i].icon:=s;
      ReadLn (f,s); delete (s,1,3); usbtn[i].hint:=s;
      ReadLn (f,s); delete (s,1,3); val (s,usbtn[i].axis,err);
      if err<>0 then showmessage ('Error reading button no. '+IntToStr(i));
      ReadLn (f,s); delete (s,1,3); s:=trim(s); usbtn[i].visib:=StrToBool(s);
      ReadLn (f,s);  //dummy
      ReadLn (f,s);  //dummy
      set_act (i);
    end;
    tbl_loaded:=true;
    CloseFile(f);
  end;
end;


procedure Tf_usrbtn.show_buttons;
begin
  if chb_edit.Checked then begin
  usrbtn1.Visible:= true; usrbtn1.Enabled:= true;
  usrbtn2.Visible:= true; usrbtn2.Enabled:= true;
  usrbtn3.Visible:= true; usrbtn3.Enabled:= true;
  usrbtn4.Visible:= true; usrbtn4.Enabled:= true;
  usrbtn5.Visible:= true; usrbtn5.Enabled:= true;
  usrbtn6.Visible:= true; usrbtn6.Enabled:= true;
  usrbtn7.Visible:= true; usrbtn7.Enabled:= true;
  usrbtn8.Visible:= true; usrbtn8.Enabled:= true;
  usrbtn9.Visible:= true; usrbtn9.Enabled:= true;
 end
 else begin
  usrbtn1.Visible:= usbtn[1].visib;
  usrbtn2.Visible:= usbtn[2].visib;
  usrbtn3.Visible:= usbtn[3].visib;
  usrbtn4.Visible:= usbtn[4].visib;
  usrbtn5.Visible:= usbtn[5].visib;
  usrbtn6.Visible:= usbtn[6].visib;
  usrbtn7.Visible:= usbtn[7].visib;
  usrbtn8.Visible:= usbtn[8].visib;
  usrbtn9.Visible:= usbtn[9].visib;
  usrbtn1.Enabled:=usbtn[1].line1<>'';
  usrbtn2.Enabled:=usbtn[2].line1<>'';
  usrbtn3.Enabled:=usbtn[3].line1<>'';
  usrbtn4.Enabled:=usbtn[4].line1<>'';
  usrbtn5.Enabled:=usbtn[5].line1<>'';
  usrbtn6.Enabled:=usbtn[6].line1<>'';
  usrbtn7.Enabled:=usbtn[7].line1<>'';
  usrbtn8.Enabled:=usbtn[8].line1<>'';
  usrbtn9.Enabled:=usbtn[9].line1<>'';
 end;
end;

procedure Tf_usrbtn.chb_editChange(Sender: TObject);
begin
 show_buttons;
end;

procedure Tf_usrbtn.chb_showhintChange(Sender: TObject);
begin
  lb_Pos.ShowHint:= chb_showhint.Checked;
  lb_e1.ShowHint:= chb_showhint.Checked;
  lb_e2.ShowHint:= chb_showhint.Checked;
  lb_move.ShowHint:= chb_showhint.Checked;
  spe_axis.ShowHint:= chb_showhint.Checked;
  chb_edit.ShowHint:= chb_showhint.Checked;
  usrbtn1.ShowHint:= chb_showhint.Checked;
  usrbtn2.ShowHint:= chb_showhint.Checked;
  usrbtn3.ShowHint:= chb_showhint.Checked;
  usrbtn4.ShowHint:= chb_showhint.Checked;
  usrbtn5.ShowHint:= chb_showhint.Checked;
  usrbtn6.ShowHint:= chb_showhint.Checked;
  usrbtn7.ShowHint:= chb_showhint.Checked;
  usrbtn8.ShowHint:= chb_showhint.Checked;
  usrbtn9.ShowHint:= chb_showhint.Checked;
  btn_close.ShowHint:= chb_showhint.Checked;
  btn_stop.ShowHint:= chb_showhint.Checked;
  btn_save.ShowHint:= chb_showhint.Checked;
  btn_load.ShowHint:= chb_showhint.Checked;
end;


procedure Tf_usrbtn.FormClose(Sender: TObject);
begin
  Timer1.Enabled:=false;
end;

procedure Tf_usrbtn.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
 if Msg.CharCode=27 then btn_stopClick (nil);
end;

procedure Tf_usrbtn.FormShow(Sender: TObject);
begin
 whatread:=0;
 spe_axis.MaxValue:=HighAxisNo;
 spe_axis.MinValue:=LowAxisNo;
 spe_axis.Value:=LowAxisNo;
 spe_axis.Enabled:=smc_count>1;
 lb_unit.Caption:=actunit[spe_axis.Value];
 Timer1.Enabled:=true;
 chb_edit.Checked:=false;
 ActShowStatus;
 usrbtn1.Enabled:=usbtn[1].line1<>'';
 usrbtn2.Enabled:=usbtn[2].line1<>'';
 usrbtn3.Enabled:=usbtn[3].line1<>'';
 usrbtn4.Enabled:=usbtn[4].line1<>'';
 usrbtn5.Enabled:=usbtn[5].line1<>'';
 usrbtn6.Enabled:=usbtn[6].line1<>'';
 usrbtn7.Enabled:=usbtn[7].line1<>'';
 usrbtn8.Enabled:=usbtn[8].line1<>'';
 usrbtn9.Enabled:=usbtn[9].line1<>'';
end;


procedure Tf_usrbtn.ActShowStatus;
begin
 lb_Pos.Visible:=smc_avail[spe_axis.Value];
 lb_e1.Visible:=smc_avail[spe_axis.Value];
 lb_e2.Visible:=smc_avail[spe_axis.Value];
 lb_move.Visible:=smc_avail[spe_axis.Value];
 lb_unit.Caption:=actunit[spe_axis.Value];
 lb_unit.Visible:=smc_avail[spe_axis.Value];
end;

procedure Tf_usrbtn.spe_axisChange(Sender: TObject);
begin
 ActShowStatus;
end;

function Tf_usrbtn.read_position:boolean;
var s,stp:string;
    err,readerr:integer;
    dmy:double;
begin
 err:=0; readerr:=0; stp:='';
 s:=smc_cmd_v2('','np',spe_axis.Value,1);
 val (trim (s),dmy,readerr);
 stp:=FormatFloat(display_pos[spe_axis.Value],abs(dmy*sc_fac[spe_axis.Value]));
 if dmy<0 then stp:='-'+stp else stp:='+'+stp;
 if (length (s)>7) and (readerr=0) then lb_pos.Caption:=stp else begin
  lb_pos.Caption:='###########';
  inc (err);
 end;
 read_position:= err=0;
end;

function Tf_usrbtn.read_limitsw:boolean;
var s:string;
begin
 read_limitsw:=true;
 s:=trim (smc_cmd_v2('','getswst',spe_axis.Value,1));
 if (length(s)=3) and ((s[1]='0') or (s[1]='1')) and ((s[3]='0') or (s[3]='1')) then begin
  if s[1]='0' then lb_E1.Color:=clLime else lb_E1.Color:=clred;
  if s[3]='0' then lb_E2.Color:=clLime else lb_E2.Color:=clred;
 end
 else begin
  lb_E1.Color:=clGray;
  lb_E2.Color:=clGray;
  read_limitsw:=false;
 end;
end;

procedure Tf_usrbtn.Timer1Timer(Sender: TObject);
 var s:string;
    cnt:integer;
    read_ok:boolean;
begin
 inc (whatread); read_ok:=true;
 case whatread of
  1,6 :read_ok:=read_Position;
  3,8:read_ok:=move_end;
  2,7:read_ok:=read_Limitsw;
 end;
 if read_ok then Timer1.Interval:= pollingtime else begin
  if tcpip_select=false then serl_port.RaiseExcept:=false else eth_port.RaiseExcept:=false;
  Timer1.Enabled:=false;
  Timer1.Interval:=pollingtime*10;
  cnt:=0;
  repeat
   inc (cnt);
   if tcpip_select=false then s:=serl_port.Recvstring(50) else s:=eth_port.RecvString(50);
   Application.ProcessMessages;
  until (s='') or (cnt>25);
  Timer1.Enabled:= true;
  if tcpip_select then serl_port.RaiseExcept:=true else eth_port.RaiseExcept:=true;
 end;
 if whatread=10 then whatread:=0;
end;


function Tf_usrbtn.move_end:boolean;
var i,err:integer;
    s:string;
    b:byte;
begin
 vc2_moveend:=true; err:=0; i:=1;
  while (i<=16) and (vc2_moveend=true) do begin
  if smc_avail[i] then begin
   s:=trim (smc_cmd_v2('','nst',i,1));
   val (s,b,err);
   if err<>0 then b:=1;
   b:=b and 1;
   if b=1 then vc2_moveend:=false;
  end;
  inc (i);
 end;
 button_status(vc2_moveend);
 If vc2_moveend then lb_move.Color:=clLime else lb_move.Color:=clRed;
 move_end:=err=0;
end;


initialization
  {$I u_usrbtn.lrs}

end.

