{***************************************************************************
 *   Copyright (C) 2006-2013 by Bernhard Gross                             *
 *   b.gross@pimicos.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************}

unit u_venus;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,LCLType,
  Buttons,u_exchange,u_talktosmc, ExtCtrls, u_delay,u_pause, Spin, Menus,u_editline,u_editvc2, LMessages;

type

  { Tf_venus }

  Tf_venus = class(TForm)
    btn_close: TBitBtn;
    btn_start: TBitBtn;
    btn_pause: TBitBtn;
    btn_top: TBitBtn;
    btn_prev: TBitBtn;
    btn_next: TBitBtn;
    btn_bottom: TBitBtn;
    btn_stop: TBitBtn;
    ed_loop: TEdit;
    gbx_axis: TGroupBox;
    gbx_loop: TGroupBox;
    lb_move: TLabel;
    lb_unit: TLabel;
    lb_loopcnt: TLabel;
    lb_pos: TLabel;
    lbx_cmds: TListBox;
    lbx_hist: TListBox;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    btn_edit: TSpeedButton;
    btn_open: TSpeedButton;
    spe_axis: TSpinEdit;
    Timer1: TTimer;
    procedure btn_closeClick(Sender: TObject);
    procedure btn_openClick(Sender: TObject);
    procedure btn_startClick(Sender: TObject);
    procedure btn_pauseClick(Sender: TObject);
    procedure btn_topClick(Sender: TObject);
    procedure btn_prevClick(Sender: TObject);
    procedure btn_nextClick(Sender: TObject);
    procedure btn_bottomClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure ed_loopEditingDone(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormShortCut(var Msg: TLMKey; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure lbx_cmdsClick(Sender: TObject);
    procedure lbx_cmdsDblClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure spe_axisChange(Sender: TObject);
    procedure spe_axisKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure btn_editClick(Sender: TObject);
  private
    { private declarations }
     vc2_activ, vc2_pause,vc2_abbr,vc2_ready,vc2_moveend,vc2_chg,randmve:boolean;
     act,rp,rpact:Integer;
     what_read:byte;
     procedure Buttonstatus;
     procedure cmd_list_cleanup;
     procedure ShowHist(s: string);
     function show_pos: integer;
     procedure vc2_move;
     Procedure move_end;

  public
    { public declarations }
  end; 

var
  f_venus: Tf_venus;

implementation

{ Tf_venus }

procedure Tf_venus.ShowHist (s:string);
begin
 s:=StringReplace(s,',','.',[rfReplaceAll]);
 lbx_hist.Items.Add (s);
 while (lbx_hist.Count>100) do lbx_hist.Items.Delete(0);
 if lbx_hist.items.Count>8 then lbx_hist.TopIndex:=lbx_hist.Count-10;
end;

procedure Tf_venus.cmd_list_cleanup;
var s,t:string;
    i,nv,err:integer;
begin
 for i:=0 to lbx_cmds.Items.Count-1 do begin
  s:= trim(lbx_cmds.Items[i]);
  if s='' then s:='# Empty line';
  if s[1]<>'#' then begin
   s:= lowercase (s);
   s:=StringReplace(s,'  ',' ',[rfReplaceAll]);
   s:=StringReplace(s,',','.',[rfReplaceAll]);
   if pos ('delay_ms ',s)>0 then begin
    t:=s;
    delete (t,1,pos(' ',t));
    val (t,nv,err);
    if (err=0) then begin
     if nv<0 then s:='delay_ms 1000'
     else if nv>99999 then s:='delay_ms 99999'
     else s:='delay_ms '+IntToStr(nv);
    end
    else s:='delay_ms 1000';
   end;
   if pos ('delay ',s)>0 then begin
    t:=s;
    delete (t,1,pos(' ',t));
    val (t,nv,err);
    if (err=0) then begin
     if nv<0 then s:='delay 1000'
     else if nv>99999 then s:='delay 99999'
     else s:='delay '+IntToStr(nv);
    end
    else s:='delay 1000';
   end;
  end;
  Application.ProcessMessages;
  lbx_cmds.Items[i]:=s;
 end;
end;

procedure Tf_venus.Buttonstatus;
var rndmv:boolean;
begin
 rndmv:= pos ('nrandmove',lbx_cmds.Items[act])>1;
 btn_close.Enabled:=not vc2_activ;
 btn_start.Enabled:=((vc2_activ=false) and (vc2_pause=false) and (act<>lbx_cmds.Items.Count-1)) or (vc2_pause=true);
 btn_pause.Enabled:=(vc2_activ=true) and (rndmv=false) and (vc2_pause=false);
 btn_top.Enabled:=(lbx_cmds.ItemIndex>0) and (not vc2_activ or vc2_pause) and vc2_moveend and (vc2_pause=false);
 btn_prev.Enabled:=(lbx_cmds.ItemIndex>0) and (not vc2_activ or vc2_pause)and vc2_moveend and (vc2_pause=false);
 btn_next.Enabled:=(lbx_cmds.ItemIndex<lbx_cmds.Items.Count-1) and (not vc2_activ or vc2_pause or rndmv)and vc2_moveend and (vc2_pause=false);
 btn_bottom.Enabled:=(lbx_cmds.ItemIndex<lbx_cmds.Items.Count-1) and (not vc2_activ or vc2_pause)and vc2_moveend and (vc2_pause=false);
 btn_stop.Enabled:=vc2_activ;
 ed_loop.Enabled:= not vc2_activ;
 spe_axis.Enabled:=(vc2_activ=false) and (smc_count>1);
 btn_edit.Enabled:= not vc2_activ;
 btn_open.Enabled:= not vc2_activ;
end;

procedure Tf_venus.vc2_move;
var s,cmd:string;
    err,readerr,ax:integer;
    direct:boolean;
    t_strt,t_act:comp;
    dmy:double;
    dt:TTimestamp;
begin
 rpact:=0; vc2_activ:=true; err:=0; randmve:=false;
 while (rpact<rp)and (vc2_abbr=false) do begin
  Buttonstatus;
  lb_loopcnt.Caption:='Loop '+IntToStr(rpact+1)+' of '+IntToStr(rp);
  while (act<lbx_cmds.Items.Count-1) and (vc2_abbr=false) do begin
   direct:=false;
   if pos ('#',lbx_cmds.Items[act])=0 then begin
    cmd:=lbx_cmds.Items[act];
    if pos (';',cmd)>0 then begin
      direct:=true;
      delete (cmd,1,1);
      cmd:=trim (cmd);
     end;
     ShowHist (cmd);
     if (pos('readpos',cmd)=0) and (pos('delay',cmd)=0)and (pos('pause',cmd)=0) and (vc2_abbr=false) then begin
      cmd_check (cmd);
      if smc_return=0 then s:=smc_cmd_v2(cmd,'',0,0) else if pos('-',cmd)=0 then s:=smc_cmd_v2(cmd,'',0,smc_return);
      if s<>'' then ShowHist('  '+s);
     end;
    end;
    if (pos ('nrandmove',lbx_cmds.Items[act])>0)and (vc2_abbr=false) then begin
     Buttonstatus;
     randmve:=true;
    end;
    sleep (20);
    if direct=false then move_end;
    repeat
     Application.ProcessMessages;
     sleep (pollingtime);
     move_end;
    until ((vc2_moveend=true) and (randmve=false)) or (vc2_abbr=true) or (direct=true);
    if (pos ('pause',lbx_cmds.Items[act])>0)and (vc2_abbr=false) then begin
     F_pause.ShowModal;
     vc2_abbr:=abreak;
     if abreak then smc_cmd_v2(#3,'',0,0);
    end;
    if (pos ('delay ',lbx_cmds.Items[act])>0) and (vc2_abbr=false) then begin
     s:=lbx_cmds.Items[act];
      delete (s,1,pos(' ',s));
      val (s,dl,err);
      if err<>0 then dl:=0;
      F_delay.ShowModal;
      vc2_abbr:=abreak;
     if abreak then smc_cmd_v2(#3,'',0,0);
    end;
     if (pos ('delay_ms ',lbx_cmds.Items[act])>0) and (vc2_abbr=false) then begin
      s:=lbx_cmds.Items[act];
      delete (s,1,pos(' ',s));
      val (s,dl,err);
      if (err<>0) and (dl<99999) then dl:=0;
      dt:=DateTimeToTimeStamp(now);
      t_strt:=TimeStampToMSecs(dt);
      repeat
       Application.ProcessMessages;
       dt:=DateTimeToTimeStamp(now);
       t_act:=TimeStampToMSecs(dt);
      until (t_strt+dl<=t_act) or (vc2_abbr=true);
     end;
     if (pos ('readpos ',lbx_cmds.Items[act])>0) and (vc2_abbr=false) then begin
      s:=lbx_cmds.Items[act];
      delete (s,1,pos(' ',s));
      s:=trim (s);
      val (s,ax,err);
      if (err=0) and (smc_avail[ax]=true) then begin
       s:=smc_cmd_v2('','np',ax,1);
       val (trim (s),dmy,readerr);
       if (length (s)>7) and (readerr=0) then begin
        s:=FormatFloat(display_pos[ax],abs(dmy*sc_fac[ax]));
        if dmy<0 then s:='-'+s else s:='+'+s;
        ShowHist ('  '+s+actunit[ax]);
       end
       else ShowHist(' ERROR!');
      end;
     end;
    if (vc2_abbr=false)and (vc2_chg=false) then inc (act);
    if vc2_abbr then  act:=lbx_cmds.Items.Count-1;
    if act<>lbx_cmds.Items.Count then lbx_cmds.ItemIndex:=act else vc2_ready:=true;
    Buttonstatus;
    vc2_chg:=false;
   end;
   inc (rpact);
   if (rpact<> rp) and (vc2_abbr=false) then begin
    act:=0;
    lbx_cmds.ItemIndex:=act;
    lbx_cmds.Selected[0]:=true;
   end
   else vc2_activ:=false;
   Buttonstatus;
 end;
end;

Procedure Tf_venus.move_end;
var i,err:integer;
    s:string;
    b:byte;
begin
 vc2_moveend:=true; err:=0; i:=0;  s:='';
 while (i<=16) and (vc2_moveend=true) do begin
  Application.ProcessMessages;
  if smc_avail[i] then begin
   s:=trim (smc_cmd_v2('','nst',i,1));
   val (s,b,err);
   if err<>0 then b:=1;
   b:=b and 1;
   if b=1 then vc2_moveend:=false;
   sleep (pollingtime);
  end;
  inc (i);
 end;
 If (vc2_moveend=true) and (vc2_pause=true) then Buttonstatus;
 If vc2_moveend then lb_move.Color:=clLime else lb_move.Color:=clRed;
 If (err<>0) or (s='') then lb_move.Color:=clGray else begin
  show_pos;
  sleep (pollingtime);
 end;
end;

procedure Tf_venus.FormShow(Sender: TObject);
var i,err:integer;
    s:string;
begin
 f_venus.Caption:='Venus2-Execute '+venusfile;
 Timer1.Interval:=pollingtime;
 move_end;
 Timer1.Enabled:=true;
 rp:=1; what_read:=0;
 if (newvc2=true) and (lbx_cmds.Items.Count=0) then lbx_cmds.Items.Add('<<< READY >>>');
 cmd_list_cleanup;
 for i:=0 to lbx_cmds.Items.Count-1 do begin
  if pos('# cycles ',lbx_cmds.Items[i])>0 then begin
   s:= lbx_cmds.Items[i];
   delete (s,1,9);
   val (s,rp,err);
   if err<>0 then rp:=1;
  end;
 end;
 act:=0;
 lbx_cmds.ItemIndex:=0;
 lbx_cmds.Selected[0]:=true;
 vc2_activ:=false;
 vc2_pause:=false;
 vc2_chg:=false;
 move_end;
 rpact:=0;
 ed_loop.Text:= IntToStr(rp);
 lb_loopcnt.Caption:='Loop '+IntToStr(rpact+1)+' of '+IntToStr(rp);
 lb_move.ShowHint:=bshowhint;
 lbx_cmds.ShowHint:=bshowhint;
 lb_pos.ShowHint:=bshowhint;
 ed_loop.ShowHint:=bshowhint;
 lbx_hist.ShowHint:=bshowhint;
 btn_edit.ShowHint:=bshowhint;
 Buttonstatus;
 If smc_count>0 then begin
   for i:=1 to Last_Ctrl do if smc_avail[i] then spe_axis.MaxValue:=i;
   for i:= Last_Ctrl downto 1 do if smc_avail[i] then spe_axis.MinValue:=i;
   spe_axis.Value:=spe_axis.MinValue;
  end
  else begin
   spe_axis.MinValue:=1;
   spe_axis.MaxValue:=1;
   spe_axis.Value:=1;
  end;
  lb_unit.Caption:=actunit[spe_axis.Value];
  err:=0;
  {$IFDEF LINUX}
    btn_start.Color:=cllime;
    btn_pause.Color:=cllime;
    btn_top.Color:=cllime;
    btn_prev.Color:=cllime;
    btn_next.Color:=cllime;
    btn_bottom.Color:=cllime;
    btn_stop.Color:=cllime;
    btn_start.Color:=clTeal;
    btn_pause.Color:=clTeal;
    btn_top.Color:=clTeal;
    btn_prev.Color:=clTeal;
    btn_next.Color:=clTeal;
    btn_bottom.Color:=clTeal;
    btn_stop.Color:=clTeal;
  {$ENDIF}
   move_end;
end;

procedure Tf_venus.lbx_cmdsClick(Sender: TObject);
begin
 if vc2_activ then lbx_cmds.ItemIndex:=act else begin
  act:=lbx_cmds.ItemIndex;
  Buttonstatus;
 end;
end;

procedure Tf_venus.lbx_cmdsDblClick(Sender: TObject);
var err:integer;
    s:string;
begin
  if lbx_cmds.Items.Count>1 then begin
    if (vc2_activ=false) and (lbx_cmds.Items.count-1<>lbx_cmds.ItemIndex) then begin
     editstr:=lbx_cmds.Items[lbx_cmds.ItemIndex];
     f_editline.ShowModal;
     if f_editline.ModalResult=mrOK then begin
      lbx_cmds.Items[lbx_cmds.ItemIndex]:=editstr;
     end;
    end;
    cmd_list_cleanup;
    if pos('# cycles ',lbx_cmds.Items[lbx_cmds.ItemIndex])>0 then begin
     s:= lbx_cmds.Items[lbx_cmds.ItemIndex];
     delete (s,1,9);
     val (s,rp,err);
     if err<>0 then rp:=1;
     ed_loop.Text:= IntToStr(rp);
    end;
  end;
end;

procedure Tf_venus.MenuItem1Click(Sender: TObject);
begin
 lbx_hist.Clear;
end;

procedure Tf_venus.MenuItem2Click(Sender: TObject);
begin
 SaveDialog1.FileName:='';
 SaveDialog1.Filter:='Venus2-Files (*.vc2)|*.vc2|Text-Files (*.txt)|*.txt|All Files (*.*)|*.*';
 SaveDialog1.DefaultExt:='.vc2';
 SaveDialog1.InitialDir:=ProgramDir+DirSep+'venus2';
 if (SaveDialog1.Execute) and (SaveDialog1.FileName<>SaveDialog1.InitialDir) then begin
 lbx_hist.Items.SaveToFile(SaveDialog1.FileName);
 end;
end;

function Tf_venus.show_pos:integer;
var s:string;
    readerr:integer;
    dmy:double;
begin
 readerr:=0;
 if smc_avail [spe_axis.Value] then begin
   s:=smc_cmd_v2('','np',spe_axis.Value,1);
   val (trim (s),dmy,readerr);
   if (length (s)>7) and (readerr=0) then begin
    s:=FormatFloat(display_pos[spe_axis.Value],abs (dmy*sc_fac[spe_axis.Value]));
    if dmy < 0 then s:='-'+s else s:='+'+s;
    lb_pos.Caption:=s;
    Timer1.Interval:=pollingtime;
   end
   else begin
    lb_pos.Caption:='###########';
    Timer1.Interval:=pollingtime*10;
   end;
   lb_unit.Caption:=actunit[spe_axis.Value];
   Application.ProcessMessages;
 end;
 show_pos:=readerr;
end;

procedure Tf_venus.spe_axisChange(Sender: TObject);
begin
  lb_pos.Visible:=smc_avail [spe_axis.Value];
  lb_unit.Visible:=smc_avail [spe_axis.Value];
  show_pos;
end;

procedure Tf_venus.spe_axisKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
var nw,err:integer;
begin
 if ord(key)=VK_RETURN then begin
  val (spe_axis.Caption,nw,err);
  if (err=0) and (nw in [1..Last_Ctrl]) then begin
   spe_axis.Value:=nw;
   spe_axisChange(nil);
  end;
 end;
end;

procedure Tf_venus.Timer1Timer(Sender: TObject);
begin
 show_pos;
end;

procedure Tf_venus.btn_editClick(Sender: TObject);
var i,err:Integer;
    s:String;
begin
 f_editvc2.mm_cmds.Clear;
 for I:= 0 to lbx_cmds.Items.Count-2 do f_editvc2.mm_cmds.Lines.Add(lbx_cmds.Items[i]);
 f_editvc2.ShowModal;
 if f_editvc2.ModalResult=mrOK then begin
  lbx_cmds.Clear;
  for i:= 0 to f_editvc2.mm_cmds.Lines.Count-1 do begin
   s:=trim (f_editvc2.mm_cmds.Lines[i]);
   if (s<>'') and (s[1]<>'#') then s:= LowerCase(s);
   if s<>'' then lbx_cmds.items.Add (s);
   if pos('# cycles ',lowercase (s))>0 then begin
    delete (s,1,9);
    val (s,rp,err);
    if err<>0 then rp:=1;
   end;
  end;
  lbx_cmds.Items.Add('<<< READY >>>');
 end
 else if lbx_cmds.Items.Count=0 then lbx_cmds.Items.Add('<<< READY >>>');
 ed_loop.Text:= IntToStr(rp);
 act:=0;
 lbx_cmds.ItemIndex:=0;
 lbx_cmds.Selected[0]:=true;
 cmd_list_cleanup;
 f_venus.Caption:='Venus2-Execute '+venusfile;
 Buttonstatus;
 newvc2:=false;
end;

procedure Tf_venus.btn_startClick(Sender: TObject);
begin
 if act<> lbx_cmds.Items.Count-1 then begin
  if vc2_pause=false then begin
   act:=lbx_cmds.ItemIndex;
   vc2_activ:=true;
   vc2_abbr:=false;
   vc2_ready:=false;
   Buttonstatus;
   Application.ProcessMessages;
   vc2_move;
  end
  else vc2_pause:=false;
 end;
end;

procedure Tf_venus.btn_closeClick(Sender: TObject);
begin
 vc2_abbr:=true;
 smc_cmd_v2(#3,'',0,0);
 close;
end;

procedure Tf_venus.btn_openClick(Sender: TObject);
var i,err:Integer;
    s:String;
begin
 OpenDialog1.InitialDir:=ProgramDir+DirSep+'venus2';
 OpenDialog1.Filter:='Venus2-Files (*.vc2)|*.vc2|Text-Files (*.txt)|*.txt|All Files (*.*)|*.*';
 OpenDialog1.DefaultExt:='.vc2';
 If (OpenDialog1.Execute)and(OpenDialog1.FileName<>OpenDialog1.InitialDir)and(FileExists(OpenDialog1.FileName))then begin
  venusfile:=OpenDialog1.FileName;
  newvc2:=false;
  lbx_cmds.Items.LoadFromFile(venusfile);
  lbx_cmds.Items.Add('<<< READY >>>');
  act:=0;
  lbx_cmds.ItemIndex:=0;
  lbx_cmds.Selected[0]:=true;
  cmd_list_cleanup;
  for i:=0 to lbx_cmds.Items.Count-1 do begin
   if pos('# cycles ',lbx_cmds.Items[i])>0 then begin
    s:= lbx_cmds.Items[i];
    delete (s,1,9);
    val (s,rp,err);
    if err<>0 then rp:=1;
   end;
  end;
  f_venus.Caption:='Venus2-Execute '+venusfile;
  ed_loop.Text:= IntToStr(rp);
  Buttonstatus;
  newvc2:=false;
 end;
end;

procedure Tf_venus.btn_pauseClick(Sender: TObject);
begin
  vc2_pause:=true;
  Buttonstatus;
  if vc2_pause then begin
   repeat
     move_end;
     sleep (25);
    Application.ProcessMessages;
   until (vc2_abbr) or (vc2_pause=false);
  end;
  Buttonstatus;
end;

procedure Tf_venus.btn_topClick(Sender: TObject);
begin
  act:=0;
  rpact:=0;
  lbx_cmds.ItemIndex:=act;
  lbx_cmds.Selected[0]:=true;
  Buttonstatus;
end;

procedure Tf_venus.btn_prevClick(Sender: TObject);
begin
  dec (act);
  vc2_chg:=true;
  lbx_cmds.ItemIndex:=act;
  Buttonstatus;
end;

procedure Tf_venus.btn_nextClick(Sender: TObject);
begin
  if pos ('nrandmove',lbx_cmds.Items [act])>0 then begin
   smc_cmd_v2(#3,'',0,0);
   randmve:=false;
  end;
  inc (act);
  vc2_chg:=true;
  lbx_cmds.ItemIndex:=act;
  Buttonstatus;
end;

procedure Tf_venus.btn_bottomClick(Sender: TObject);
begin
  act:=lbx_cmds.Items.Count-1;
  vc2_chg:=true;
  lbx_cmds.ItemIndex:=act;
  Buttonstatus;
end;

procedure Tf_venus.btn_stopClick(Sender: TObject);
begin
 smc_cmd_v2(#3,'',0,0);
 vc2_abbr:=true;
 vc2_activ:=false;
 vc2_pause:=false;
 randmve:=false;
 act:=lbx_cmds.Items.Count-1;
 repeat
  sleep (25);
  move_end;
 until vc2_moveend;
 Buttonstatus;
end;

procedure Tf_venus.ed_loopEditingDone(Sender: TObject);
var nval,err:Integer;
begin
 err:=0;
 val (ed_loop.Text,nval,err);
 if err=0 then rp:=nval else ed_loop.Text:=IntToStr(rp);
 lb_loopcnt.Caption:='Loop '+IntToStr(rpact+1)+' of '+IntToStr(rp);
 ed_loop.Text:=IntToStr(rp);
end;

procedure Tf_venus.FormClose(Sender: TObject);
begin
 Timer1.Enabled:=false;
 smc_cmd_v2(#3,'',0,0);
end;

procedure Tf_venus.FormShortCut(var Msg: TLMKey; var Handled: Boolean);
begin
 if Msg.CharCode=27 then btn_stopClick (nil);
end;

initialization
  {$I u_venus.lrs}

end.

